<?php
if ( !class_exists( 'WP_List_Table' ) ) {
  require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}

class DashboardWPTR extends WP_List_Table {
	public function __construct() {
		global $status, $page;
		parent::__construct( array(
			'singular' => 'wptrafficmax',
			'plural' => 'wptrafficmaxs',
			'ajax' => false
		));
  }
	
	private function wptrafficmax_get_data() {
		global $wpdb;
		$tableCoupons = $wpdb->prefix . 'wptr_coupons';
		$tableVideos = $wpdb->prefix . 'wptr_videos';
		$tableWysiwygs = $wpdb->prefix. 'wptr_wysiwygs';
		$tableInterstitials = $wpdb->prefix . 'wptr_interstitials';
		$tableOptins = $wpdb->prefix . 'wptr_optins';
		$table2StepOptins = $wpdb->prefix . 'wptr_2stepoptins';
		$tableExit = $wpdb->prefix . 'wptr_exit';
		
		$getDataCoupons = $wpdb->get_results( "SELECT * FROM $tableCoupons ORDER BY last_modified DESC" );
		$getDataVideos = $wpdb->get_results( "SELECT * FROM $tableVideos ORDER BY last_modified DESC" );
		$getDataWysiwyg = $wpdb->get_results( "SELECT * FROM $tableWysiwygs ORDER BY last_modified DESC" );
		$getDataInterstitial = $wpdb->get_results( "SELECT * FROM $tableInterstitials ORDER BY last_modified DESC" );
		$getDataOptins = $wpdb->get_results( "SELECT * FROM $tableOptins ORDER BY last_modified DESC" );
		$getData2StepOptins = $wpdb->get_results( "SELECT * FROM $table2StepOptins ORDER BY last_modified DESC" );
		$getDataExit = $wpdb->get_results( "SELECT * FROM $tableExit ORDER BY last_modified DESC" );
		
		if ( !empty( $getDataCoupons ) ) {
			foreach ( $getDataCoupons as $dCoupon ) {
				$id = $dCoupon->id;
				$popupName = $dCoupon->name;
				$type = 'Social Gate';
				if ( $dCoupon->status ) {
					$status = '<span class="wptr-status-switch-1 wptr-node-1-' . $id . '">Enabled</span>&nbsp;(<a href="#" class="wptr-status-disable" data-id="' . $id . '" data-pnode="1" data-pname="' . $popupName . '">Disable</a>)';
				} else {
					$status = '<span class="wptr-status-switch-2 wptr-node-1-' . $id . '">Disabled</span>&nbsp;(<a href="#" class="wptr-status-enable" data-id="' . $id . '" data-pnode="1" data-pname="' . $popupName . '">Enable</a>)';
				}
				$lastModified = $dCoupon->last_modified;
				$arrayCoupons[] = array(
					'pId' => $id,
					'pName' => $popupName,
					'pType' => $type,
					'pStatus' => $status,
					'pLastModified' => self::time_elapsed_string( strtotime( $lastModified ) ),
					'pUnique' => 1
				);
			}
		} else {
			$arrayCoupons = array();
		}
		
		if ( !empty( $getDataVideos ) ) {
			foreach ( $getDataVideos as $dVideo ) {
				$id = $dVideo->id;
				$popupName = $dVideo->name;
				$type = 'Video';
				if ( $dVideo->status ) {
					$status = '<span class="wptr-status-switch-1 wptr-node-2-' . $id . '">Enabled</span>&nbsp;(<a href="#" class="wptr-status-disable" data-id="' . $id . '" data-pnode="2" data-pname="' . $popupName . '">Disable</a>)';
				} else {
					$status = '<span class="wptr-status-switch-2 wptr-node-2-' . $id . '">Disabled</span>&nbsp;(<a href="#" class="wptr-status-enable" data-id="' . $id . '" data-pnode="2" data-pname="' . $popupName . '">Enable</a>)';
				}
				$lastModified = $dVideo->last_modified;
				$arrayVideos[] = array(
					'pId' => $id,
					'pName' => $popupName,
					'pType' => $type,
					'pStatus' => $status,
					'pLastModified' => self::time_elapsed_string( strtotime( $lastModified ) ),
					'pUnique' => 2
				);
			}
		} else {
			$arrayVideos = array();
		}
		
		if ( !empty( $getDataWysiwyg ) ) {
			foreach ( $getDataWysiwyg as $dWysiwyg ) {
				$id = $dWysiwyg->id;
				$popupName = $dWysiwyg->name;
				$type = 'Custom';
				if ( $dWysiwyg->status ) {
					$status = '<span class="wptr-status-switch-1 wptr-node-3-' . $id . '">Enabled</span>&nbsp;(<a href="#" class="wptr-status-disable" data-id="' . $id . '" data-pnode="3" data-pname="' . $popupName . '">Disable</a>)';
				} else {
					$status = '<span class="wptr-status-switch-2 wptr-node-3-' . $id . '">Disabled</span>&nbsp;(<a href="#" class="wptr-status-enable" data-id="' . $id . '" data-pnode="3" data-pname="' . $popupName . '">Enable</a>)';
				}
				$lastModified = $dWysiwyg->last_modified;
				$arrayWysiwyg[] = array(
					'pId' => $id,
					'pName' => $popupName,
					'pType' => $type,
					'pStatus' => $status,
					'pLastModified' => self::time_elapsed_string( strtotime( $lastModified ) ),
					'pUnique' => 3
				);
			}
		} else {
			$arrayWysiwyg = array();
		}
		
		if ( !empty( $getDataInterstitial ) ) {
			foreach ( $getDataInterstitial as $dInterstitial ) {
				$id = $dInterstitial->id;
				$popupName = $dInterstitial->name;
				$type = 'Interstitial';
				if ( $dInterstitial->status ) {
					$status = '<span class="wptr-status-switch-1 wptr-node-4-' . $id . '">Enabled</span>&nbsp;(<a href="#" class="wptr-status-disable" data-id="' . $id . '" data-pnode="4" data-pname="' . $popupName . '">Disable</a>)';
				} else {
					$status = '<span class="wptr-status-switch-2 wptr-node-4-' . $id . '">Disabled</span>&nbsp;(<a href="#" class="wptr-status-enable" data-id="' . $id . '" data-pnode="4" data-pname="' . $popupName . '">Enable</a>)';
				}
				$lastModified = $dInterstitial->last_modified;
				$arrayInterstitial[] = array(
					'pId' => $id,
					'pName' => $popupName,
					'pType' => $type,
					'pStatus' => $status,
					'pLastModified' => self::time_elapsed_string( strtotime( $lastModified ) ),
					'pUnique' => 4
				);
			}
		} else {
			$arrayInterstitial = array();
		}
		
		if ( !empty( $getDataOptins ) ) {
			foreach ( $getDataOptins as $dOptin ) {
				$id = $dOptin->id;
				$popupName = $dOptin->name;
				$type = 'Optin';
				if ( $dOptin->status ) {
					$status = '<span class="wptr-status-switch-1 wptr-node-5-' . $id . '">Enabled</span>&nbsp;(<a href="#" class="wptr-status-disable" data-id="' . $id . '" data-pnode="5" data-pname="' . $popupName . '">Disable</a>)';
				} else {
					$status = '<span class="wptr-status-switch-2 wptr-node-5-' . $id . '">Disabled</span>&nbsp;(<a href="#" class="wptr-status-enable" data-id="' . $id . '" data-pnode="5" data-pname="' . $popupName . '">Enable</a>)';
				}
				$lastModified = $dOptin->last_modified;
				$arrayOptin[] = array(
					'pId' => $id,
					'pName' => $popupName,
					'pType' => $type,
					'pStatus' => $status,
					'pLastModified' => self::time_elapsed_string( strtotime( $lastModified ) ),
					'pUnique' => 5
				);
			}
		} else {
			$arrayOptin = array();
		}
		
		if ( !empty( $getData2StepOptins ) ) {
			foreach ( $getData2StepOptins as $d2StepOptin ) {
				$id = $d2StepOptin->id;
				$popupName = $d2StepOptin->name;
				$type = '2 Step Optin';
				if ( $d2StepOptin->status ) {
					$status = '<span class="wptr-status-switch-1 wptr-node-6-' . $id . '">Enabled</span>&nbsp;(<a href="#" class="wptr-status-disable" data-id="' . $id . '" data-pnode="6" data-pname="' . $popupName . '">Disable</a>)';
				} else {
					$status = '<span class="wptr-status-switch-2 wptr-node-6-' . $id . '">Disabled</span>&nbsp;(<a href="#" class="wptr-status-enable" data-id="' . $id . '" data-pnode="6" data-pname="' . $popupName . '">Enable</a>)';
				}
				$lastModified = $d2StepOptin->last_modified;
				$array2StepOptin[] = array(
					'pId' => $id,
					'pName' => $popupName,
					'pType' => $type,
					'pStatus' => $status,
					'pLastModified' => self::time_elapsed_string( strtotime( $lastModified ) ),
					'pUnique' => 6
				);
			}
		} else {
			$array2StepOptin = array();
		}
		
		if ( !empty( $getDataExit ) ) {
			foreach ( $getDataExit as $dExit ) {
				$id = $dExit->id;
				$popupName = $dExit->name;
				$type = 'Exit';
				if ( $dExit->status ) {
					$status = '<span class="wptr-status-switch-1 wptr-node-7-' . $id . '">Enabled</span>&nbsp;(<a href="#" class="wptr-status-disable" data-id="' . $id . '" data-pnode="7" data-pname="' . $popupName . '">Disable</a>)';
				} else {
					$status = '<span class="wptr-status-switch-2 wptr-node-7-' . $id . '">Disabled</span>&nbsp;(<a href="#" class="wptr-status-enable" data-id="' . $id . '" data-pnode="7" data-pname="' . $popupName . '">Enable</a>)';
				}
				$lastModified = $dExit->last_modified;
				$arrayExits[] = array(
					'pId' => $id,
					'pName' => $popupName,
					'pType' => $type,
					'pStatus' => $status,
					'pLastModified' => self::time_elapsed_string( strtotime( $lastModified ) ),
					'pUnique' => 7
				);
			}
		} else {
			$arrayExits = array();
		}
		
		$mergeArrays = array_merge( $arrayCoupons, $arrayVideos, $arrayWysiwyg, $arrayInterstitial, $arrayOptin, $array2StepOptin, $arrayExits );
		return $mergeArrays;
	}
	
	private function time_elapsed_string( $ptime ) {
		$etime = time() - $ptime;

		if ($etime < 1) {
		return 'just now';
		}

		$a = array( 12 * 30 * 24 * 60 * 60 => 'year',
		30 * 24 * 60 * 60 => 'month',
		24 * 60 * 60 => 'day',
		60 * 60 => 'hour',
		60 => 'minute',
		1 => 'second'
		);

		foreach ($a as $secs => $str) {
			$d = $etime / $secs;
			if ($d >= 1) {
			$r = round($d);
			return $r . ' ' . $str . ($r > 1 ? 's' : '') . ' ago';
			}
		}
	}
	
	public function get_columns() {
		$columns = array(
			'pName' => 'Name',
			'pType' => 'Type',
			'pStatus' => 'Status',
			'pLastModified' => 'Last Modified'
		);
		return $columns;
	}
	
	public function column_default( $item, $column_name ) {
		switch ( $column_name ) {
			case 'pName':
			case 'pType':
			case 'pStatus':
			case 'pLastModified':
				return $item[$column_name];
			default:
				return print_r( $item, true );
		}
	}
	
	public function column_pName( $item ) {
		if ( $item['pUnique'] == 1 ) {
			$node = 'addcouponpopup';
		} elseif ( $item['pUnique'] == 2 ) {
			$node = 'addvideopopup';
		} elseif ( $item['pUnique'] == 3 ) {
			$node = 'addwysiwygpopup';
		} elseif ( $item['pUnique'] == 4 ) {
			$node = 'addinterstitialpopup';
		} elseif ( $item['pUnique'] == 5 ) {
			$node = 'addoptinpopup';
		} elseif ( $item['pUnique'] == 6 ) {
			$node = 'add2stepoptinpopup';
		} elseif ( $item['pUnique'] == 7 ) {
			$node = 'addexitpopup';
		}
		$actions = array(
			'edit' => sprintf( '<span class="dashicons-before dashicons-admin-tools"></span>&nbsp;<a href="?page=wptrafficmax&node=%s&popupid=%d">Edit</a>', $node, $item['pId'] ),
			'delete' => sprintf('<span class="dashicons-before dashicons-admin-generic"></span>&nbsp;<a href="#" class="wptr-popup-remove" data-pid="%d" data-pname="%s" data-pnode="%d">Delete</a>', $item['pId'], $item['pName'], $item['pUnique'] )
		);
		return sprintf( '%1$s %2$s', $item['pName'], $this->row_actions( $actions ) );
	}
	
	public function prepare_items() {
		$columns = self::get_columns();
		$hidden = array();
		$sortable = array();
		$this->_column_headers = array( $columns, $hidden, $sortable );
		$per_page = 10;
		$current_page = $this->get_pagenum();
		$total_items = count( self::wptrafficmax_get_data() );
		$this->found_data = array_slice( self::wptrafficmax_get_data(), ( ( $current_page - 1 ) * $per_page ), $per_page );
		$this->set_pagination_args( array(
			'total_items' => $total_items, 
			'per_page' => $per_page
		) );
		$this->items = $this->found_data;
	}
}
?>