<?php
/*
Plugin Name: WP Traffic Max
Plugin URI: http://wptrafficmax.com
Description: Plugin for presenting ads in different ways.
Version: 1.4
Author: BWI Press
Author URI: http://bwipress.com
License: Copyright 2014, All rights reserved
*/

error_reporting(0);
define( 'WPTRAFFICMAX_VERSION', '1.4' );
define( 'WPTRAFFICMAX_PLUGIN_DIR', plugin_dir_path( __FILE__ ) );
define( 'WPTRAFFICMAX_LICENSE_URL', '' );

class WPTrafficMax {
	public function __construct() {
		register_activation_hook( __FILE__, array( 'WPTrafficMax', 'run_wptrafficmax_activate' ) );
		add_action( 'init', array( 'WPTrafficMax', 'wptrafficmax_init' ) );
		add_action( 'admin_menu', array( 'WPTrafficMax', 'wptrafficmax_admin_menu' ) );
		add_action( 'admin_enqueue_scripts', array( 'WPTrafficMax', 'wptrafficmax_enqueue_scripts' ) );
		add_action( 'wp_enqueue_scripts', array( 'WPTrafficMax', 'wptrafficmax_enqueue_scripts_page' ) );
		add_action( 'admin_init', array( 'WPTrafficMax', 'wptrafficmax_admin_init' ) );
		add_action( 'template_redirect', array( 'WPTrafficMax', 'wptrafficmax_template_redirect' ) );
		add_action( 'wp_head', array( 'WPTrafficMax', 'wptrafficmax_wp_head' ) );
		add_action( 'wp_footer', array( 'WPTrafficMax', 'wptrafficmax_wp_footer' ) );
		add_action( 'wp_ajax_wptrafficmax_ajax', array( 'WPTrafficMax', 'wptrafficmax_ajax' ) );
		add_action( 'admin_head', array( 'WPTrafficMax', 'wptrafficmax_admin_head' ) );
		add_action( 'admin_footer', array( 'WPTrafficMax', 'wptrafficmax_admin_footer' ) );
	}
	
	public function run_wptrafficmax_activate( $networkwide ) {
		global $wpdb, $switched;
		if ( function_exists( 'is_multisite' ) && is_multisite() ) {
			if ( $networkwide ) {
				$old_blog	= $wpdb->blogid;
				$blogids	= $wpdb->get_col( $wpdb->prepare( "SELECT blog_id FROM $wpdb->blogs" ) );
				foreach ( $blogids as $blogid ) {
					switch_to_blog( $blogid );
					self::wptrafficmax_activate();
				}
				switch_to_blog( $old_blog );
				return;
			}
		}
		self::wptrafficmax_activate();
	}
	
	public function wptrafficmax_init() {
		ob_start();
		require_once( WPTRAFFICMAX_PLUGIN_DIR . 'code/autoupdate.php' );
		$MyUpdateChecker = new PluginUpdateChecker( 'http://wptrafficmax.com/pluginrepo/metadata.php', __FILE__, 'wptrafficmax' );
	}
	
	public function wptrafficmax_activate() {
		if ( !function_exists( 'dbDelta' ) ) {
			require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		}
		
		global $wpdb;
		$tableCoupons = $wpdb->prefix . 'wptr_coupons';
		$tableVideos = $wpdb->prefix . 'wptr_videos';
		$tableWysiwygs = $wpdb->prefix. 'wptr_wysiwygs';
		$tableInterstitials = $wpdb->prefix . 'wptr_interstitials';
		$tableOptins = $wpdb->prefix . 'wptr_optins';
		$table2StepOptins = $wpdb->prefix . 'wptr_2stepoptins';
		$tableExit = $wpdb->prefix . 'wptr_exit';
		
		$sql = <<<SQL
CREATE TABLE {$tableCoupons} (
id INT(11) unsigned NOT NULL AUTO_INCREMENT,
name VARCHAR(255) NOT NULL,
autoclose INT(1) NOT NULL,
countdown_autoclose INT(11) NOT NULL,
delay INT(11) NOT NULL,
cookie_time INT(11) NOT NULL,
cookie_interval INT(1) NOT NULL,
autosize_popup INT(1) NOT NULL,
width INT(11) NOT NULL,
width_option VARCHAR(28) NOT NULL,
height INT(11) NOT NULL,
height_option VARCHAR(28) NOT NULL,
bgcolor VARCHAR(28) NOT NULL,
border_width VARCHAR(28) NOT NULL,
border_round VARCHAR(28) NOT NULL,
border_shadow VARCHAR(28) NOT NULL,
coupon_1 VARCHAR(255) NOT NULL,
content_coupon1_above TEXT NOT NULL,
content_coupon1_below TEXT NOT NULL,
coupon_2 VARCHAR(255) NOT NULL,
content_coupon2_above TEXT NOT NULL,
content_coupon2_below TEXT NOT NULL,
display_on_posts VARCHAR(255) NOT NULL,
display_on_pages VARCHAR(255) NOT NULL,
display_on_cats VARCHAR(255) NOT NULL,
onclose INT(1) NOT NULL,
redirect_url VARCHAR(255) NOT NULL,
status INT(1) NOT NULL,
created DATETIME NOT NULL,
last_modified DATETIME NOT NULL,
popup_type VARCHAR(28) NOT NULL,
PRIMARY KEY id (id))
SQL;
dbDelta($sql);
	
	$sql = <<<SQL
CREATE TABLE {$tableVideos} (
id INT(11) unsigned NOT NULL AUTO_INCREMENT,
name VARCHAR(255) NOT NULL,
autoclose INT(1) NOT NULL,
countdown_autoclose INT(11) NOT NULL,
delay INT(11) NOT NULL,
cookie_time INT(11) NOT NULL,
cookie_interval INT(1) NOT NULL,
autosize_popup INT(1) NOT NULL,
width INT(11) NOT NULL,
width_option VARCHAR(28) NOT NULL,
height INT(11) NOT NULL,
height_option VARCHAR(28) NOT NULL,
bgcolor VARCHAR(28) NOT NULL,
border_width VARCHAR(28) NOT NULL,
border_round VARCHAR(28) NOT NULL,
border_shadow VARCHAR(28) NOT NULL,
video_autoplay INT(1) NOT NULL,
video_id VARCHAR(255) NOT NULL,
video_size INT(11) NOT NULL,
video_width INT(11) NOT NULL,
video_height INT(11) NOT NULL,
onpause VARCHAR(255) NOT NULL,
redirect_url_onpause VARCHAR(255) NOT NULL,
onstop VARCHAR(255) NOT NULL,
redirect_url_onstop VARCHAR(255) NOT NULL,
onend VARCHAR(255) NOT NULL,
redirect_url_onend VARCHAR(255) NOT NULL,
content_video_above TEXT NOT NULL,
content_video_below TEXT NOT NULL,
display_on_posts VARCHAR(255) NOT NULL,
display_on_pages VARCHAR(255) NOT NULL,
display_on_cats VARCHAR(255) NOT NULL,
onclose INT(1) NOT NULL,
redirect_url VARCHAR(255) NOT NULL,
status INT(1) NOT NULL,
created DATETIME NOT NULL,
last_modified DATETIME NOT NULL,
popup_type VARCHAR(28) NOT NULL,
PRIMARY KEY id (id))
SQL;
dbDelta($sql);

$sql = <<<SQL
CREATE TABLE {$tableWysiwygs} (
id INT(11) unsigned NOT NULL AUTO_INCREMENT,
name VARCHAR(255) NOT NULL,
autoclose INT(1) NOT NULL,
countdown_autoclose INT(11) NOT NULL,
delay INT(11) NOT NULL,
cookie_time INT(11) NOT NULL,
cookie_interval INT(1) NOT NULL,
autosize_popup INT(1) NOT NULL,
width INT(11) NOT NULL,
width_option VARCHAR(28) NOT NULL,
height INT(11) NOT NULL,
height_option VARCHAR(28) NOT NULL,
bgcolor VARCHAR(28) NOT NULL,
border_width VARCHAR(28) NOT NULL,
border_round VARCHAR(28) NOT NULL,
border_shadow VARCHAR(28) NOT NULL,
content TEXT NOT NULL,
display_on_posts VARCHAR(255) NOT NULL,
display_on_pages VARCHAR(255) NOT NULL,
display_on_cats VARCHAR(255) NOT NULL,
onclose INT(1) NOT NULL,
redirect_url VARCHAR(255) NOT NULL,
status INT(1) NOT NULL,
created DATETIME NOT NULL,
last_modified DATETIME NOT NULL,
popup_type VARCHAR(28) NOT NULL,
PRIMARY KEY id (id))
SQL;
dbDelta($sql);

$sql = <<<SQL
CREATE TABLE {$tableInterstitials} (
id INT(11) unsigned NOT NULL AUTO_INCREMENT,
name VARCHAR(255) NOT NULL,
autoclose INT(1) NOT NULL,
countdown_autoclose INT(11) NOT NULL,
cookie_time INT(11) NOT NULL,
cookie_interval INT(1) NOT NULL,
bgcolor_1 VARCHAR(28) NOT NULL,
textcolor_1 VARCHAR(28) NOT NULL,
content_1 TEXT NOT NULL,
bgcolor_2 VARCHAR(28) NOT NULL,
textcolor_2 VARCHAR(28) NOT NULL,
content_2 TEXT NOT NULL,
skiptext VARCHAR(255) NOT NULL,
skiptextcolor VARCHAR(28) NOT NULL,
skiptextfontsize INT(11) NOT NULL,
display_on_posts VARCHAR(255) NOT NULL,
display_on_pages VARCHAR(255) NOT NULL,
display_on_cats VARCHAR(255) NOT NULL,
onclose INT(1) NOT NULL,
redirect_url VARCHAR(255) NOT NULL,
status INT(1) NOT NULL,
created DATETIME NOT NULL,
last_modified DATETIME NOT NULL,
popup_type VARCHAR(28) NOT NULL,
PRIMARY KEY id (id))
SQL;
dbDelta($sql);

$sql = <<<SQL
CREATE TABLE {$tableOptins} (
id INT(11) unsigned NOT NULL AUTO_INCREMENT,
name VARCHAR(255) NOT NULL,
autoclose INT(1) NOT NULL,
countdown_autoclose INT(11) NOT NULL,
delay INT(11) NOT NULL,
cookie_time INT(11) NOT NULL,
cookie_interval INT(1) NOT NULL,
autosize_popup INT(1) NOT NULL,
width INT(11) NOT NULL,
width_option VARCHAR(28) NOT NULL,
height INT(11) NOT NULL,
height_option VARCHAR(28) NOT NULL,
bgcolor VARCHAR(28) NOT NULL,
border_width VARCHAR(28) NOT NULL,
border_round VARCHAR(28) NOT NULL,
border_shadow VARCHAR(28) NOT NULL,
content TEXT NOT NULL,
display_on_posts VARCHAR(255) NOT NULL,
display_on_pages VARCHAR(255) NOT NULL,
display_on_cats VARCHAR(255) NOT NULL,
onclose INT(1) NOT NULL,
redirect_url VARCHAR(255) NOT NULL,
onsubscribe VARCHAR(255) NOT NULL,
onsubscribe_page INT(11) NOT NULL,
status INT(1) NOT NULL,
created DATETIME NOT NULL,
last_modified DATETIME NOT NULL,
popup_type VARCHAR(28) NOT NULL,
PRIMARY KEY id (id))
SQL;
dbDelta($sql);

$sql = <<<SQL
CREATE TABLE {$table2StepOptins} (
id INT(11) unsigned NOT NULL AUTO_INCREMENT,
name VARCHAR(255) NOT NULL,
autoclose INT(1) NOT NULL,
countdown_autoclose INT(11) NOT NULL,
delay INT(11) NOT NULL,
cookie_time INT(11) NOT NULL,
cookie_interval INT(1) NOT NULL,
autosize_popup INT(1) NOT NULL,
width INT(11) NOT NULL,
width_option VARCHAR(28) NOT NULL,
height INT(11) NOT NULL,
height_option VARCHAR(28) NOT NULL,
bgcolor VARCHAR(28) NOT NULL,
border_width VARCHAR(28) NOT NULL,
border_round VARCHAR(28) NOT NULL,
border_shadow VARCHAR(28) NOT NULL,
content1 TEXT NOT NULL,
button_text VARCHAR(128) NOT NULL,
button_style VARCHAR(128) NOT NULL,
button_size VARCHAR(128) NOT NULL,
button_color VARCHAR(128) NOT NULL,
content2 TEXT NOT NULL,
display_on_posts VARCHAR(255) NOT NULL,
display_on_pages VARCHAR(255) NOT NULL,
display_on_cats VARCHAR(255) NOT NULL,
onclose INT(1) NOT NULL,
redirect_url VARCHAR(255) NOT NULL,
onsubscribe VARCHAR(255) NOT NULL,
onsubscribe_page INT(11) NOT NULL,
status INT(1) NOT NULL,
created DATETIME NOT NULL,
last_modified DATETIME NOT NULL,
popup_type VARCHAR(28) NOT NULL,
PRIMARY KEY id (id))
SQL;
dbDelta($sql);

$sql = <<<SQL
CREATE TABLE {$tableExit} (
id INT(11) unsigned NOT NULL AUTO_INCREMENT,
name VARCHAR(255) NOT NULL,
content TEXT NOT NULL,
url VARCHAR(255) NOT NULL,
cookie_time INT(11) NOT NULL,
cookie_interval INT(1) NOT NULL,
exclude_on_pages INT(1) NOT NULL,
display_on_posts VARCHAR(255) NOT NULL,
display_on_pages VARCHAR(255) NOT NULL,
display_on_cats VARCHAR(255) NOT NULL,
status INT(1) NOT NULL,
created DATETIME NOT NULL,
last_modified DATETIME NOT NULL,
popup_type VARCHAR(28) NOT NULL,
PRIMARY KEY id (id))
SQL;
dbDelta($sql);
	}
	
	public function wptrafficmax_admin_menu() {
		add_menu_page( __( 'WP Traffic Max', 'wptrafficmax' ),
			__( 'WP Traffic Max', 'wptrafficmax' ),
			'manage_options',
			'wptrafficmax',
			array( 'WPTrafficMax', 'wptrafficmax_display_page' ), plugins_url( 'images/wptr-white.ico', __FILE__ )
		);
	}
	
	public function wptrafficmax_enqueue_scripts() {
		wp_enqueue_style( 'wptrafficmax-snippets', plugins_url('css/snippet.css', __FILE__ ), false, 'screen' );
	
		wp_enqueue_script( 'jquery' );
		wp_enqueue_media();
		wp_enqueue_script( 'wptrafficmax-upload', plugins_url( 'js/wptrafficmax-upload.js', __FILE__ ), array(), get_bloginfo( 'version' ), true );
		wp_enqueue_script( 'wptrafficmax-jscolor', plugins_url( 'js/jscolor/jscolor.js', __FILE__ ), 'jquery' );
		wp_enqueue_script( 'wptrafficmax-app', plugins_url( 'js/app.js', __FILE__ ), 'jquery' );
		wp_enqueue_script( 'wptrafficmax-noty', plugins_url( 'js/jquery.noty.packaged.min.js', __FILE__ ), 'jquery' );
		wp_enqueue_script( 'wptrafficmax-snippets', plugins_url( 'js/jquery.snippet.min.js', __FILE__ ), 'jquery' );
		wp_enqueue_script( 'wptrafficmax-countdowntimer', plugins_url( 'js/jquery.countdownTimer.min.js', __FILE__ ), 'jquery' );
		
		wp_localize_script( 'wptrafficmax-app', 'wptrafficmax_params', array( 'wptrafficmax_nonce' => wp_create_nonce( 'wptrafficmax-nonce' ) ) );
	}
	
	public function wptrafficmax_enqueue_scripts_page() {
		wp_enqueue_script( 'jquery' );
		wp_enqueue_script( 'wptrafficmax-cookie', plugins_url( 'js/jquery.cookie.js', __FILE__ ), 'jquery' );
		wp_enqueue_script( 'wptrafficmax-countdowntimer', plugins_url( 'js/jquery.countdownTimer.min.js', __FILE__ ), 'jquery' );
	}
	
	private function render_view( $name ) {
		$file = WPTRAFFICMAX_PLUGIN_DIR . 'views/'. $name . '.php';
		include( $file );
	}
	
	private function _include( $name ) {
		$file = WPTRAFFICMAX_PLUGIN_DIR . 'code/'. $name . '.php';
		include( $file );
	}
	
	private function _curl ( $url ) {
		$options = array( 
			CURLOPT_RETURNTRANSFER => true,
			CURLOPT_HEADER         => false,
			CURLOPT_FOLLOWLOCATION => true, 
			CURLOPT_USERAGENT      => 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/29.0.1547.66 Safari/537.36',
			CURLOPT_AUTOREFERER    => true,
			CURLOPT_TIMEOUT        => 120, 
			CURLOPT_MAXREDIRS      => 10,
			CURLOPT_SSL_VERIFYPEER => false 
	  );

		$ch = curl_init( $url ); 
	  curl_setopt_array( $ch, $options ); 
	  $content = curl_exec( $ch );
	  curl_close( $ch );
	  return $content;
	}
	
	public function wptrafficmax_display_page() {
		/** Nulled by SCOR **/
		if ( !empty( $_POST['submit'] ) && $_POST['submit'] == 'Activate License' ) {
			update_option( 'wptr_license_status', 'ok' );
			update_option( 'wptr_license_level', 1 );
			wp_safe_redirect( admin_url() . 'admin.php?page=wptrafficmax');
			exit();
		}
		/* Nulled by SCOR */
		
		$wptrLicenseStatus = get_option( 'wptr_license_status' );
		$wptrLicenseLevel = get_option( 'wptr_license_level' );
		if ( empty( $wptrLicenseStatus ) && empty( $wptrLicenseLevel ) ) {
			?>
			<br/><br/>
			<div class="updated"><h3>Activate your plugin</h3></div>
			<div class="updated">
			<form action="" method="post">
				<p>
				<input type="email" name="biztechlicenseemail" id="biztechlicenseemail" placeholder="Enter licence email" size="25" style="height:30px;"/>
				<em>Enter your valid license email</em>
				<?php submit_button( 'Activate License' ); ?>
				</p>
			</form>
			</div>
			<?php
		} elseif ( $wptrLicenseStatus == 'ok' && !empty( $wptrLicenseLevel ) ) {
			?>
			<div class="wrap" style="font-size:14px !important;">
				<h2>
				Traffic Max
				<?php
				$arrayBack = array( 'addcouponpopup', 'addvideopopup', 'addwysiwygpopup', 'addinterstitialpopup', 'addoptinpopup', 'add2stepoptinpopup', 'addexitpopup' );
				if ( in_array($_GET['node'], $arrayBack ) ) { echo '<a href="' . admin_url() . 'admin.php?page=wptrafficmax" class="add-new-h2">Back</a>'; }?>
				</h2>
				<?php
					$tab = isset( $_GET['node'] ) ? $_GET['node'] : "dashboard";
				?>
				<?php
				if ( $_GET['node'] == 'addcouponpopup' ) {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab nav-tab-active" href="?page=wptrafficmax&node=addcouponpopup">Social Gate</a>
					</h2>
					<?php
				} elseif ( $_GET['node'] == 'addvideopopup' ) {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab nav-tab-active" href="?page=wptrafficmax&node=addvideopopup">Video</a>
					</h2>
					<?php
				} elseif ( $_GET['node'] == 'addwysiwygpopup' ) {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab nav-tab-active" href="?page=wptrafficmax&node=addwysiwygpopup">Custom</a>
					</h2>
					<?php
				} elseif ( $_GET['node'] == 'addinterstitialpopup' ) {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab nav-tab-active" href="?page=wptrafficmax&node=addinterstitialpopup">Interstitial</a>
					</h2>
					<?php
				} elseif ( $_GET['node'] == 'addoptinpopup' ) {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab nav-tab-active" href="?page=wptrafficmax&node=addoptinpopup">Optin</a>
					</h2>
					<?php
				} elseif ( $_GET['node'] == 'add2stepoptinpopup' ) {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab nav-tab-active" href="?page=wptrafficmax&node=add2stepoptinpopup">2 Step Optin</a>
					</h2>
					<?php
				} elseif ( $_GET['node'] == 'addexitpopup' ) {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab nav-tab-active" href="?page=wptrafficmax&node=addexitpopup">Exit</a>
					</h2>
					<?php
				} else {
					?>
					<h2 class="nav-tab-wrapper" style="padding-left:0px !important">
						<a class="nav-tab <?php if($tab == "dashboard") echo "nav-tab-active"; ?>" href="?page=wptrafficmax&node=dashboard">Dashboard</a>
						<a class="nav-tab <?php if($tab == "settings") echo "nav-tab-active"; ?>" href="?page=wptrafficmax&node=settings">Settings</a>
					</h2>
					<?php
				}
				?>
				<?php
				if ( $_GET['node'] == 'settings' ) {
					self::render_view( 'settings' );
				} elseif ( $_GET['node'] == 'addexitpopup' ) {
					self::render_view( 'addexitpopup' );
				} elseif ( $_GET['node'] == 'add2stepoptinpopup' ) {
					self::render_view( 'add2stepoptinpopup' );
				} elseif ( $_GET['node'] == 'addoptinpopup' ) {
					self::render_view( 'addoptinpopup' );
				} elseif ( $_GET['node'] == 'addcouponpopup' ) {
					self::render_view( 'addcouponpopup' );
				} elseif ( $_GET['node'] == 'addvideopopup' ) {
					self::render_view( 'addvideopopup' );
				} elseif ( $_GET['node'] == 'addwysiwygpopup') {
					self::render_view( 'addwysiwygpopup' );
				} elseif ( $_GET['node'] == 'addinterstitialpopup' ) {
					self::render_view( 'addinterstitialpopup' );
				} else {
					self::render_view( 'dashboard' );
				}
				?>
			</div>
			<?php
		}
	}
	
	public function wptrafficmax_admin_init() {
		global $wpdb;
		$tableCoupons = $wpdb->prefix . 'wptr_coupons';
		$tableVideos = $wpdb->prefix . 'wptr_videos';
		$tableWysiwygs = $wpdb->prefix. 'wptr_wysiwygs';
		$tableInterstitials = $wpdb->prefix . 'wptr_interstitials';
		$tableOptins = $wpdb->prefix . 'wptr_optins';
		$table2StepOptins = $wpdb->prefix . 'wptr_2stepoptins';
		$tableExit = $wpdb->prefix . 'wptr_exit';
		
		if ( isset( $_POST['submit_settings'] ) ) {
			$username = $_POST['wptr_settings_username'];
			$password = $_POST['wptr_settings_password'];
			update_option( 'wptr_settings_username', $username );
			update_option( 'wptr_settings_password', $password );
		}
		
		if ( isset( $_POST['submit_2stepoptin'] ) ) {
			$popupName  = sanitize_text_field( $_POST['wptr_2stepoptin_name'] );
			$autoClose = sanitize_text_field( $_POST['wptr_2stepoptin_autoclose'] );
			if ( empty( $autoClose ) ) {
				$autoClose = 0;
			} else {
				$autoClose = 1;
			}
			$countdownAutoclose = sanitize_text_field( $_POST['wptr_2stepoptin_countdown_autoclose'] );
			$delay = sanitize_text_field( $_POST['wptr_2stepoptin_delay'] );
			$cookieTime = sanitize_text_field( $_POST['wptr_2stepoptin_cookie_time'] );
			$cookieInterval = sanitize_text_field( $_POST['wptr_2stepoptin_cookie_interval'] );
			$autosizePopup = sanitize_text_field( $_POST['wptr_2stepoptin_autosize_popup'] );
			if ( !empty( $autosizePopup ) ) {
				$autosizePopup = 1;
			} else {
				$autosizePopup = 0;
			}
			$width = sanitize_text_field( $_POST['wptr_2stepoptin_width'] );
			$widthOption = sanitize_text_field( $_POST['wptr_2stepoptin_width_option'] );
			$height = sanitize_text_field( $_POST['wptr_2stepoptin_height'] );
			$heightOption = sanitize_text_field( $_POST['wptr_2stepoptin_height_option'] );
			$backgroundColor = sanitize_text_field( $_POST['wptr_2stepoptin_bgcolor'] );
			$borderWidth = ''; #sanitize_text_field( $_POST['wptr_optin_borderwidth'] );
			$borderRound = ''; #sanitize_text_field( $_POST['wptr_optin_borderrounding'] );
			$borderShadow = ''; #sanitize_text_field( $_POST['wptr_optin_borderdropshadow'] );
			$content1 = $_POST['wptr-2stepoptin-content1'];
			$buttonText = sanitize_text_field( $_POST['wptr_2stepoptin_buttontext'] );
			$buttonStyle = sanitize_text_field( $_POST['wptr_2stepoptin_buttonstyle'] );
			$buttonSize = sanitize_text_field( $_POST['wptr_2stepoptin_buttonsize'] );
			$buttonColor = sanitize_text_field( $_POST['wptr_2stepoptin_buttoncolor'] );
			$content2 = $_POST['wptr-2stepoptin-content2'];
			
			$doPosts = $_POST['wptr_2stepoptin_displayonposts'];
			if ( is_null( $doPosts ) ) {
				$displayOnPosts = '';
			} else {
				foreach( $doPosts as $postId ) {
					$arrDisplayOnPosts[] = '{'.$postId.'}';
				}
				$displayOnPosts = implode( ',', $arrDisplayOnPosts );
			}
			
			$doPages = $_POST['wptr_2stepoptin_displayonpages'];
			if ( is_null( $doPages ) ) {
				$displayOnPages = '';
			} else {
				foreach( $doPages as $pageId ) {
					$arrDisplayOnPages[] = '{'.$pageId.'}';
				}
				$displayOnPages = implode( ',', $arrDisplayOnPages );
			}
			
			$doCats = $_POST['wptr_2stepoptin_displayoncategories'];
			if ( is_null( $doCats ) ) {
				$displayOnCats = array();
			} else {
				foreach( $doCats as $catId ) {
					$arrDisplayOnCats[] = '{'.$catId.'}';
				}
				$displayOnCats = implode( ',', $arrDisplayOnCats );
			}
			
			$onClose = sanitize_text_field( $_POST['wptr_2stepoptin_actiononclose'] );
			if ( empty( $onClose ) ) {
				$onClose = 0;
			} else {
				$onClose = 1;
			}
			
			$redirectUrl = sanitize_text_field( $_POST['wptr_2stepoptin_redirecttourl'] );
			$onSubscribe = sanitize_text_field( $_POST['wptr_2stepoptin_onsubscribe'] );
			$onSubscribePage = sanitize_text_field( $_POST['wptr_2stepoptin_onsubscribe_page'] );
			$currentTime = current_time( 'mysql' );
			$popupId = sanitize_text_field( $_POST['wptr_hidden_2stepoptin'] );
			if ( !empty( $_POST['wptr_2stepoptin_preview'] ) ) {
				$oPreview = 'yes';
			} else {
				$oPreview = 'no';
			}
			
			if ( empty( $popupId ) ) {
				$insertOptin = $wpdb->query( $wpdb->prepare( "INSERT INTO $table2StepOptins SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, content1 = %s, button_text = %s, button_style = %s, button_size = %s, button_color = %s, content2 = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, onsubscribe = %s, onsubscribe_page = %d, status = %d, created = %s, last_modified = %s, popup_type = %s", $popupName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $content1, $buttonText, $buttonStyle, $buttonSize, $buttonColor, $content2, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $onSubscribe, $onSubscribePage,  1, $currentTime, $currentTime, '2stepoptin' ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_2stepoptin_referer'] ) . '&popupid=' . $wpdb->insert_id . '&s3r4=added&preview=' . $oPreview );
			} else {
				$updateOptin = $wpdb->query( $wpdb->prepare( "UPDATE $table2StepOptins SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, content1 = %s, button_text = %s, button_style = %s, button_size = %s, button_color = %s, content2 = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, onsubscribe = %s, onsubscribe_page = %d,  last_modified = %s WHERE id = %d", $popupName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $content1, $buttonText, $buttonStyle, $buttonSize, $buttonColor, $content2, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $onSubscribe, $onSubscribePage, $currentTime, $popupId ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_2stepoptin_referer'] ) . '&s3r4=updated&preview=' . $oPreview );
			}
		}
		
		if ( isset( $_POST['submit_coupon'] ) ) {
			$couponName = sanitize_text_field( $_POST['wptr_coupon_name'] );
			$autoClose = sanitize_text_field( $_POST['wptr_coupon_autoclose'] );
			if ( empty( $autoClose ) ) {
				$autoClose = 0;
			} else {
				$autoClose = 1;
			}
			$countdownAutoclose = sanitize_text_field( $_POST['wptr_coupon_countdown_autoclose'] );
			$delay = sanitize_text_field( $_POST['wptr_coupon_delay'] );
			$cookieTime = sanitize_text_field( $_POST['wptr_coupon_cookie_time'] );
			$cookieInterval = sanitize_text_field( $_POST['wptr_coupon_cookie_interval'] );
			$autosizePopup = sanitize_text_field( $_POST['wptr_coupon_autosize_popup'] );
			if ( !empty( $autosizePopup ) ) {
				$autosizePopup = 1;
			} else {
				$autosizePopup = 0;
			}
			$width = sanitize_text_field( $_POST['wptr_coupon_width'] );
			$widthOption = sanitize_text_field( $_POST['wptr_coupon_width_option'] );
			$height = sanitize_text_field( $_POST['wptr_coupon_height'] );
			$heightOption = sanitize_text_field( $_POST['wptr_coupon_height_option'] );
			$backgroundColor = sanitize_text_field( $_POST['wptr_coupon_bgcolor'] );
			$borderWidth = ''; #sanitize_text_field( $_POST['wptr_coupon_borderwidth'] );
			$borderRound = ''; #sanitize_text_field( $_POST['wptr_coupon_borderrounding'] );
			$borderShadow = ''; #sanitize_text_field( $_POST['wptr_coupon_borderdropshadow'] );
			$coupon1 = sanitize_text_field( $_POST['wptr_coupon_image1'] );
			$contentCoupon1Above = $_POST['wptr-coupon-content1above'];
			$contentCoupon1Below = $_POST['wptr-coupon-content1below'];
			$coupon2 = sanitize_text_field( $_POST['wptr_coupon_image2'] );
			$contentCoupon2Above = $_POST['wptr-coupon-content2above'];
			$contentCoupon2Below = $_POST['wptr-coupon-content2below'];
			
			$doPosts = $_POST['wptr_coupon_displayonposts'];
			if ( is_null( $doPosts ) ) {
				$displayOnPosts = '';
			} else {
				foreach( $doPosts as $postId ) {
					$arrDisplayOnPosts[] = '{'.$postId.'}';
				}
				$displayOnPosts = implode( ',', $arrDisplayOnPosts );
			}
			
			$doPages = $_POST['wptr_coupon_displayonpages'];
			if ( is_null( $doPages ) ) {
				$displayOnPages = '';
			} else {
				foreach( $doPages as $pageId ) {
					$arrDisplayOnPages[] = '{'.$pageId.'}';
				}
				$displayOnPages = implode( ',', $arrDisplayOnPages );
			}
			
			$doCats = $_POST['wptr_coupon_displayoncategories'];
			if ( is_null( $doCats ) ) {
				$displayOnCats = array();
			} else {
				foreach( $doCats as $catId ) {
					$arrDisplayOnCats[] = '{'.$catId.'}';
				}
				$displayOnCats = implode( ',', $arrDisplayOnCats );
			}
			
			$onClose = sanitize_text_field( $_POST['wptr_coupon_actiononclose'] );
			if ( empty( $onClose ) ) {
				$onClose = 0;
			} else {
				$onClose = 1;
			}
			
			$redirectUrl = sanitize_text_field( $_POST['wptr_coupon_redirecttourl'] );
			$currentTime = current_time( 'mysql' );
			
			$popupId = sanitize_text_field( $_POST['wptr_hidden_coupon'] );
			if ( !empty( $_POST['wptr_coupon_preview'] ) ) {
				$oPreview = 'yes';
			} else {
				$oPreview = 'no';
			}
			
			if ( empty( $popupId ) ) {
				$insertCoupon = $wpdb->query( $wpdb->prepare( "INSERT INTO $tableCoupons SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, coupon_1 = %s, content_coupon1_above = %s, content_coupon1_below = %s, coupon_2 = %s, content_coupon2_above = %s, content_coupon2_below = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, status = %d, created = %s, last_modified = %s, popup_type = %s", $couponName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $coupon1, $contentCoupon1Above, $contentCoupon1Below, $coupon2, $contentCoupon2Above, $contentCoupon2Below, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, 1, $currentTime, $currentTime, 'coupon' ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_coupon_referer'] ) . '&popupid=' . $wpdb->insert_id . '&s3r4=added&preview=' . $oPreview );
			} else {
				$updateCoupon = $wpdb->query( $wpdb->prepare( "UPDATE $tableCoupons SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, coupon_1 = %s, content_coupon1_above = %s, content_coupon1_below = %s, coupon_2 = %s, content_coupon2_above = %s, content_coupon2_below = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, last_modified = %s WHERE id = %d ", $couponName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $coupon1, $contentCoupon1Above, $contentCoupon1Below, $coupon2, $contentCoupon2Above, $contentCoupon2Below, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $currentTime, $popupId ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_coupon_referer'] ) . '&s3r4=updated&preview=' . $oPreview );
			}
		}
		
		if ( isset( $_POST['submit_video'] ) ) {
			$videoName  = sanitize_text_field( $_POST['wptr_video_name'] );
			$autoClose = sanitize_text_field( $_POST['wptr_video_autoclose'] );
			if ( empty( $autoClose ) ) {
				$autoClose = 0;
			} else {
				$autoClose = 1;
			}
			$countdownAutoclose = sanitize_text_field( $_POST['wptr_video_countdown_autoclose'] );
			$delay = sanitize_text_field( $_POST['wptr_video_delay'] );
			$cookieTime = sanitize_text_field( $_POST['wptr_video_cookie_time'] );
			$cookieInterval = sanitize_text_field( $_POST['wptr_video_cookie_interval'] );
			$autosizePopup = sanitize_text_field( $_POST['wptr_video_autosize_popup'] );
			if ( empty( $autosizePopup ) ) {
				$autosizePopup = 0;
			} else {
				$autosizePopup = 1;
			}
			$width = sanitize_text_field( $_POST['wptr_video_width'] );
			$widthOption = sanitize_text_field( $_POST['wptr_video_width_option'] );
			$height = sanitize_text_field( $_POST['wptr_video_height'] );
			$heightOption = sanitize_text_field( $_POST['wptr_video_height_option'] );
			$backgroundColor = sanitize_text_field( $_POST['wptr_video_bgcolor'] );
			$borderWidth = ''; #sanitize_text_field( $_POST['wptr_video_borderwidth'] );
			$borderRound = ''; #sanitize_text_field( $_POST['wptr_video_borderrounding'] );
			$borderShadow = ''; #sanitize_text_field( $_POST['wptr_video_borderdropshadow'] );
			$videoAutoplay = sanitize_text_field( $_POST['wptr_video_videoautoplay'] );
			if ( empty( $videoAutoplay ) ) {
				$videoAutoplay = 0;
			} else {
				$videoAutoplay = 1;
			}
			$videoId = sanitize_text_field( $_POST['wptr_video_id'] );
			$videoSize = sanitize_text_field( $_POST['wptr_video_size'] );
			$videoWidth = sanitize_text_field( $_POST['wptr_video_videowidth'] );
			$videoHeight = sanitize_text_field( $_POST['wptr_video_videoheight'] );
			$onPause = sanitize_text_field( $_POST['wptr_video_onpause'] );
			$redirectUrlOnPause = sanitize_text_field( $_POST['wptr_video_redirecturl_onpause'] );
			$onStop  = ''; #sanitize_text_field( $_POST['wptr_video_onstop'] );
			$redirectUrlOnStop = ''; #sanitize_text_field( $_POST['wptr_video_redirecturl_onstop'] );
			$onEnd = sanitize_text_field( $_POST['wptr_video_onend'] );
			$redirectUrlOnEnd = sanitize_text_field( $_POST['wptr_video_redirecturl_onend'] );
			$contentVideoAbove = $_POST['wptr-video-contentabove'];
			$contentVideoBelow = $_POST['wptr-video-contentbelow'];
			
			$doPosts = $_POST['wptr_video_displayonposts'];
			if ( is_null( $doPosts ) ) {
				$displayOnPosts = '';
			} else {
				foreach( $doPosts as $postId ) {
					$arrDisplayOnPosts[] = '{'.$postId.'}';
				}
				$displayOnPosts = implode( ',', $arrDisplayOnPosts );
			}
			
			$doPages = $_POST['wptr_video_displayonpages'];
			if ( is_null( $doPages ) ) {
				$displayOnPages = '';
			} else {
				foreach( $doPages as $pageId ) {
					$arrDisplayOnPages[] = '{'.$pageId.'}';
				}
				$displayOnPages = implode( ',', $arrDisplayOnPages );
			}
			
			$doCats = $_POST['wptr_video_displayoncategories'];
			if ( is_null( $doCats ) ) {
				$displayOnCats = array();
			} else {
				foreach( $doCats as $catId ) {
					$arrDisplayOnCats[] = '{'.$catId.'}';
				}
				$displayOnCats = implode( ',', $arrDisplayOnCats );
			}
			
			$onClose = sanitize_text_field( $_POST['wptr_video_actiononclose'] );
			if ( empty( $onClose ) ) {
				$onClose = 0;
			} else {
				$onClose = 1;
			}
			
			$redirectUrl = sanitize_text_field( $_POST['wptr_video_redirecttourl'] );
			$currentTime = current_time( 'mysql' );
			
			$popupId = sanitize_text_field( $_POST['wptr_hidden_video'] );
			if ( !empty( $_POST['wptr_video_preview'] ) ) {
				$oPreview = 'yes';
			} else {
				$oPreview = 'no';
			}
			if ( empty( $popupId ) ) {
				$insertVideo = $wpdb->query( $wpdb->prepare( "INSERT INTO $tableVideos SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, video_autoplay = %d, video_id = %s, video_size = %d, video_width = %d, video_height = %d,  onpause = %s, redirect_url_onpause = %s, onstop = %s, redirect_url_onstop =%s, onend = %s, redirect_url_onend = %s, content_video_above = %s, content_video_below = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, status = %d, created = %s, last_modified = %s, popup_type = %s", $videoName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $videoAutoplay, $videoId, $videoSize, $videoWidth, $videoHeight, $onPause, $redirectUrlOnPause, $onStop, $redirectUrlOnStop, $onEnd, $redirectUrlOnEnd, $contentVideoAbove, $contentVideoBelow, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, 1, $currentTime, $currentTime, 'video' ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_video_referer'] ) . '&popupid=' . $wpdb->insert_id . '&s3r4=added&preview=' . $oPreview );
			} else {
				$updateVideo = $wpdb->query( $wpdb->prepare( "UPDATE $tableVideos SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, video_autoplay = %d, video_id = %s, video_size = %d, video_width = %d, video_height = %d, onpause = %s, redirect_url_onpause = %s, onstop = %s, redirect_url_onstop =%s, onend = %s, redirect_url_onend = %s, content_video_above = %s, content_video_below = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, last_modified = %s WHERE id = %d", $videoName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $videoAutoplay, $videoId, $videoSize, $videoWidth, $videoHeight, $onPause, $redirectUrlOnPause, $onStop, $redirectUrlOnStop, $onEnd, $redirectUrlOnEnd, $contentVideoAbove, $contentVideoBelow, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $currentTime, $popupId ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_video_referer'] ) . '&s3r4=updated&preview=' . $oPreview );
			}
		}
		
		if ( isset( $_POST['submit_wysiwyg'] ) ) {
			$popupName  = sanitize_text_field( $_POST['wptr_wysiwyg_name'] );
			$autoClose = sanitize_text_field( $_POST['wptr_wysiwyg_autoclose'] );
			if ( empty( $autoClose ) ) {
				$autoClose = 0;
			} else {
				$autoClose = 1;
			}
			$countdownAutoclose = sanitize_text_field( $_POST['wptr_wysiwyg_countdown_autoclose'] );
			$delay = sanitize_text_field( $_POST['wptr_wysiwyg_delay'] );
			$cookieTime = sanitize_text_field( $_POST['wptr_wysiwyg_cookie_time'] );
			$cookieInterval = sanitize_text_field( $_POST['wptr_wysiwyg_cookie_interval'] );
			$autosizePopup = sanitize_text_field( $_POST['wptr_wysiwyg_autosize_popup'] );
			if ( !empty( $autosizePopup ) ) {
				$autosizePopup = 1;
			} else {
				$autosizePopup = 0;
			}
			
			$width = sanitize_text_field( $_POST['wptr_wysiwyg_width'] );
			$widthOption = sanitize_text_field( $_POST['wptr_wysiwyg_width_option'] );
			$height = sanitize_text_field( $_POST['wptr_wysiwyg_height'] );
			$heightOption = sanitize_text_field( $_POST['wptr_wysiwyg_height_option'] );
			$backgroundColor = sanitize_text_field( $_POST['wptr_wysiwyg_bgcolor'] );
			$borderWidth = ''; #sanitize_text_field( $_POST['wptr_wysiwyg_borderwidth'] );
			$borderRound = ''; #sanitize_text_field( $_POST['wptr_wysiwyg_borderrounding'] );
			$borderShadow = ''; #sanitize_text_field( $_POST['wptr_wysiwyg_borderdropshadow'] );
			$content = $_POST['wptr-wysiwyg-popup'];
			
			$doPosts = $_POST['wptr_wysiwyg_displayonposts'];
			if ( is_null( $doPosts ) ) {
				$displayOnPosts = '';
			} else {
				foreach( $doPosts as $postId ) {
					$arrDisplayOnPosts[] = '{'.$postId.'}';
				}
				$displayOnPosts = implode( ',', $arrDisplayOnPosts );
			}
			
			$doPages = $_POST['wptr_wysiwyg_displayonpages'];
			if ( is_null( $doPages ) ) {
				$displayOnPages = '';
			} else {
				foreach( $doPages as $pageId ) {
					$arrDisplayOnPages[] = '{'.$pageId.'}';
				}
				$displayOnPages = implode( ',', $arrDisplayOnPages );
			}
			
			$doCats = $_POST['wptr_wysiwyg_displayoncategories'];
			if ( is_null( $doCats ) ) {
				$displayOnCats = array();
			} else {
				foreach( $doCats as $catId ) {
					$arrDisplayOnCats[] = '{'.$catId.'}';
				}
				$displayOnCats = implode( ',', $arrDisplayOnCats );
			}
			
			$onClose = sanitize_text_field( $_POST['wptr_wysiwyg_actiononclose'] );
			if ( empty( $onClose ) ) {
				$onClose = 0;
			} else {
				$onClose = 1;
			}
			
			$redirectUrl = sanitize_text_field( $_POST['wptr_wysiwyg_redirecttourl'] );
			$currentTime = current_time( 'mysql' );
			$popupId = sanitize_text_field( $_POST['wptr_hidden_wysiwyg'] );
			if ( !empty( $_POST['wptr_wysiwyg_preview'] ) ) {
				$oPreview = 'yes';
			} else {
				$oPreview = 'no';
			}
			
			if ( empty( $popupId ) ) {
				$insertWysiwyg = $wpdb->query( $wpdb->prepare( "INSERT INTO $tableWysiwygs SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, content = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, status = %d, created = %s, last_modified = %s, popup_type = %s", $popupName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $content, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, 1, $currentTime, $currentTime, 'wysiwyg' ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_wysiwyg_referer'] ) . '&popupid=' . $wpdb->insert_id . '&s3r4=added&preview=' . $oPreview );
			} else {
				$updateWysiwyg = $wpdb->query( $wpdb->prepare( "UPDATE $tableWysiwygs SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, content = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, last_modified = %s WHERE id = %d", $popupName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $content, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $currentTime, $popupId ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_wysiwyg_referer'] ) . '&s3r4=updated&preview=' . $oPreview );
			}
		}
		
		if ( isset( $_POST['submit_interstitial'] ) ) {
			$insterstitialName = sanitize_text_field( $_POST['wptr_interstitial_name'] );
			$autoClose = sanitize_text_field( $_POST['wptr_interstitial_autoclose'] );
			if ( empty( $autoClose ) ) {
				$autoClose = 0;
			} else {
				$autoClose = 1;
			}
			$countdownAutoclose = sanitize_text_field( $_POST['wptr_interstitial_countdown_autoclose'] );
			$cookieTime = sanitize_text_field( $_POST['wptr_interstitial_cookie_time'] );
			$cookieInterval = sanitize_text_field( $_POST['wptr_interstitial_cookie_interval'] );
			$backgroundColor1 = sanitize_text_field( $_POST['wptr_interstitial_bgcolor1'] );
			$textColor1 = sanitize_text_field( $_POST['wptr_interstitial_textcolor1'] );
			$content1 = $_POST['wptr-interstitial-popup-1'];
			$backgroundColor2 = sanitize_text_field( $_POST['wptr_interstitial_bgcolor2'] );
			$textColor2 = sanitize_text_field( $_POST['wptr_interstitial_textcolor2'] );
			$content2 = $_POST['wptr-interstitial-popup-2'];
			$skipText = sanitize_text_field( $_POST['wptr_interstitial_skiptext'] );
			$skipTextColor = sanitize_text_field( $_POST['wptr_interstitial_skiptextcolor'] );
			$skipTextFontSize = sanitize_text_field( $_POST['wptr_interstitial_skiptextfontsize'] );
			
			$doPosts = $_POST['wptr_interstitial_displayonposts'];
			if ( is_null( $doPosts ) ) {
				$displayOnPosts = '';
			} else {
				foreach( $doPosts as $postId ) {
					$arrDisplayOnPosts[] = '{'.$postId.'}';
				}
				$displayOnPosts = implode( ',', $arrDisplayOnPosts );
			}
			
			$doPages = $_POST['wptr_interstitial_displayonpages'];
			if ( is_null( $doPages ) ) {
				$displayOnPages = '';
			} else {
				foreach( $doPages as $pageId ) {
					$arrDisplayOnPages[] = '{'.$pageId.'}';
				}
				$displayOnPages = implode( ',', $arrDisplayOnPages );
			}
			
			$doCats = $_POST['wptr_interstitial_displayoncategories'];
			if ( is_null( $doCats ) ) {
				$displayOnCats = array();
			} else {
				foreach( $doCats as $catId ) {
					$arrDisplayOnCats[] = '{'.$catId.'}';
				}
				$displayOnCats = implode( ',', $arrDisplayOnCats );
			}
			
			$onClose = sanitize_text_field( $_POST['wptr_interstitial_actiononclose'] );
			if ( empty( $onClose ) ) {
				$onClose = 0;
			} else {
				$onClose = 1;
			}
			
			$redirectUrl = sanitize_text_field( $_POST['wptr_interstitial_redirecttourl'] );
			$currentTime = current_time( 'mysql' );
			$popupId = sanitize_text_field( $_POST['wptr_hidden_interstitial'] );
			if ( !empty( $_POST['wptr_interstitial_preview'] ) ) {
				$oPreview = 'yes';
			} else {
				$oPreview = 'no';
			}
			
			if ( empty( $popupId ) ) {
				$insertInterstitial = $wpdb->query( $wpdb->prepare( "INSERT INTO $tableInterstitials SET name = %s, autoclose = %d, countdown_autoclose = %d, cookie_time = %d, cookie_interval = %d, bgcolor_1 = %s, textcolor_1 = %s, content_1 = %s, bgcolor_2 = %s, textcolor_2 = %s, content_2 = %s, skiptext = %s, skiptextcolor = %s, skiptextfontsize = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, status = %d, created = %s, last_modified = %s, popup_type = %s", $insterstitialName, $autoClose, $countdownAutoclose, $cookieTime, $cookieInterval, $backgroundColor1, $textColor1, $content1, $backgroundColor2, $textColor2, $content2, $skipText, $skipTextColor, $skipTextFontSize, $displayOnPosts,  $displayOnPages, $displayOnCats, $onClose, $redirectUrl, 1, $currentTime, $currentTime, 'interstitial' ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_interstitial_referer'] ) . '&popupid=' . $wpdb->insert_id . '&s3r4=added&preview=' . $oPreview );
			} else {
				$updateInterstitial = $wpdb->query( $wpdb->prepare( "UPDATE $tableInterstitials SET name = %s, autoclose = %d, countdown_autoclose = %d, cookie_time = %d, cookie_interval = %d, bgcolor_1 = %s, textcolor_1 = %s, content_1 = %s, bgcolor_2 = %s, textcolor_2 = %s, content_2 = %s, skiptext = %s, skiptextcolor = %s, skiptextfontsize = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, last_modified = %s WHERE id = %d", $insterstitialName, $autoClose, $countdownAutoclose, $cookieTime, $cookieInterval, $backgroundColor1, $textColor1, $content1, $backgroundColor2, $textColor2, $content2, $skipText, $skipTextColor, $skipTextFontSize, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $currentTime, $popupId ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_interstitial_referer'] ) . '&s3r4=updated&preview=' . $oPreview );
			}
		}
		
		if ( isset( $_POST['submit_optin'] ) ) {
			$popupName  = sanitize_text_field( $_POST['wptr_optin_name'] );
			$autoClose = sanitize_text_field( $_POST['wptr_optin_autoclose'] );
			if ( empty( $autoClose ) ) {
				$autoClose = 0;
			} else {
				$autoClose = 1;
			}
			$countdownAutoclose = sanitize_text_field( $_POST['wptr_optin_countdown_autoclose'] );
			$delay = sanitize_text_field( $_POST['wptr_optin_delay'] );
			$cookieTime = sanitize_text_field( $_POST['wptr_optin_cookie_time'] );
			$cookieInterval = sanitize_text_field( $_POST['wptr_optin_cookie_interval'] );
			$autosizePopup = sanitize_text_field( $_POST['wptr_optin_autosize_popup'] );
			if ( !empty( $autosizePopup ) ) {
				$autosizePopup = 1;
			} else {
				$autosizePopup = 0;
			}
			$width = sanitize_text_field( $_POST['wptr_optin_width'] );
			$widthOption = sanitize_text_field( $_POST['wptr_optin_width_option'] );
			$height = sanitize_text_field( $_POST['wptr_optin_height'] );
			$heightOption = sanitize_text_field( $_POST['wptr_optin_height_option'] );
			$backgroundColor = sanitize_text_field( $_POST['wptr_optin_bgcolor'] );
			$borderWidth = ''; #sanitize_text_field( $_POST['wptr_optin_borderwidth'] );
			$borderRound = ''; #sanitize_text_field( $_POST['wptr_optin_borderrounding'] );
			$borderShadow = ''; #sanitize_text_field( $_POST['wptr_optin_borderdropshadow'] );
			$content = $_POST['wptr_optin_content'];
			
			$doPosts = $_POST['wptr_optin_displayonposts'];
			if ( is_null( $doPosts ) ) {
				$displayOnPosts = '';
			} else {
				foreach( $doPosts as $postId ) {
					$arrDisplayOnPosts[] = '{'.$postId.'}';
				}
				$displayOnPosts = implode( ',', $arrDisplayOnPosts );
			}
			
			$doPages = $_POST['wptr_optin_displayonpages'];
			if ( is_null( $doPages ) ) {
				$displayOnPages = '';
			} else {
				foreach( $doPages as $pageId ) {
					$arrDisplayOnPages[] = '{'.$pageId.'}';
				}
				$displayOnPages = implode( ',', $arrDisplayOnPages );
			}
			
			$doCats = $_POST['wptr_optin_displayoncategories'];
			if ( is_null( $doCats ) ) {
				$displayOnCats = array();
			} else {
				foreach( $doCats as $catId ) {
					$arrDisplayOnCats[] = '{'.$catId.'}';
				}
				$displayOnCats = implode( ',', $arrDisplayOnCats );
			}
			
			$onClose = sanitize_text_field( $_POST['wptr_optin_actiononclose'] );
			if ( empty( $onClose ) ) {
				$onClose = 0;
			} else {
				$onClose = 1;
			}
			
			$redirectUrl = sanitize_text_field( $_POST['wptr_optin_redirecttourl'] );
			$onSubscribe = sanitize_text_field( $_POST['wptr_optin_onsubscribe'] );
			$onSubscribePage = sanitize_text_field( $_POST['wptr_optin_onsubscribe_page'] );
			$currentTime = current_time( 'mysql' );
			$popupId = sanitize_text_field( $_POST['wptr_hidden_optin'] );
			if ( !empty( $_POST['wptr_optin_preview'] ) ) {
				$oPreview = 'yes';
			} else {
				$oPreview = 'no';
			}
			
			if ( empty( $popupId ) ) {
				$insertOptin = $wpdb->query( $wpdb->prepare( "INSERT INTO $tableOptins SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, content = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, onsubscribe = %s, onsubscribe_page = %d, status = %d, created = %s, last_modified = %s, popup_type = %s", $popupName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $content, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $onSubscribe, $onSubscribePage,  1, $currentTime, $currentTime, 'optin' ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_optin_referer'] ) . '&popupid=' . $wpdb->insert_id . '&s3r4=added&preview=' . $oPreview );
			} else {
				$updateOptin = $wpdb->query( $wpdb->prepare( "UPDATE $tableOptins SET name = %s, autoclose = %d, countdown_autoclose = %d, delay = %d, cookie_time = %d, cookie_interval = %d, autosize_popup = %d, width = %d, width_option = %s, height = %d, height_option = %s, bgcolor = %s, border_width = %s, border_round = %s, border_shadow = %s, content = %s, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, onclose = %d, redirect_url = %s, onsubscribe = %s, onsubscribe_page = %d,  last_modified = %s WHERE id = %d", $popupName, $autoClose, $countdownAutoclose, $delay, $cookieTime, $cookieInterval, $autosizePopup, $width, $widthOption, $height, $heightOption, $backgroundColor, $borderWidth, $borderRound, $borderShadow, $content, $displayOnPosts, $displayOnPages, $displayOnCats, $onClose, $redirectUrl, $onSubscribe, $onSubscribePage, $currentTime, $popupId ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_optin_referer'] ) . '&s3r4=updated&preview=' . $oPreview );
				exit;
			}
		}
		
		if ( isset( $_POST['submit_exit'] ) ) {
			$popupName  = sanitize_text_field( $_POST['wptr_exit_name'] );
			$content = sanitize_text_field( $_POST['wptr_exit_content'] );
			$optionalUrl = sanitize_text_field( $_POST['wptr_exit_url'] );
			$cookieTime = sanitize_text_field( $_POST['wptr_exit_cookie_time'] );
			$cookieInterval = sanitize_text_field( $_POST['wptr_exit_cookie_interval'] );
			
			$ePages = sanitize_text_field( $_POST['wptr_exit_excludeonpages'] );
			if ( empty( $ePages ) ) {
				$excludeOnPages = 0;
			} else {
				$excludeOnPages = 1;
			}
			
			$doPosts = $_POST['wptr_exit_displayonposts'];
			if ( is_null( $doPosts ) ) {
				$displayOnPosts = '';
			} else {
				foreach( $doPosts as $postId ) {
					$arrDisplayOnPosts[] = '{'.$postId.'}';
				}
				$displayOnPosts = implode( ',', $arrDisplayOnPosts );
			}
			
			$doPages = $_POST['wptr_exit_displayonpages'];
			if ( is_null( $doPages ) ) {
				$displayOnPages = '';
			} else {
				foreach( $doPages as $pageId ) {
					$arrDisplayOnPages[] = '{'.$pageId.'}';
				}
				$displayOnPages = implode( ',', $arrDisplayOnPages );
			}
			
			$doCats = $_POST['wptr_exit_displayoncategories'];
			if ( is_null( $doCats ) ) {
				$displayOnCats = array();
			} else {
				foreach( $doCats as $catId ) {
					$arrDisplayOnCats[] = '{'.$catId.'}';
				}
				$displayOnCats = implode( ',', $arrDisplayOnCats );
			}
			
			$popupId = sanitize_text_field( $_POST['wptr_hidden_exit'] );
			$currentTime = current_time( 'mysql' );
			if ( empty( $popupId ) ) {
				$insertWysiwyg = $wpdb->query( $wpdb->prepare( "INSERT INTO $tableExit SET name = %s, content = %s, url = %s, cookie_time = %d, cookie_interval = %d, exclude_on_pages = %d, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, status = %d, created = %s, last_modified = %s, popup_type = %s", $popupName, $content, $optionalUrl, $cookieTime, $cookieInterval, $excludeOnPages, $displayOnPosts, $displayOnPages, $displayOnCats, 1, $currentTime, $currentTime, 'exit' ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_exit_referer'] ) . '&popupid=' . $wpdb->insert_id . '&s3r4=added&preview=no' );
			} else {
				$updateWysiwyg = $wpdb->query( $wpdb->prepare( "UPDATE $tableExit SET name = %s, content = %s, url = %s, cookie_time = %d, cookie_interval = %d, exclude_on_pages = %d, display_on_posts = %s, display_on_pages = %s, display_on_cats = %s, last_modified = %s WHERE id = %d", $popupName, $content, $optionalUrl, $cookieTime, $cookieInterval, $excludeOnPages, $displayOnPosts, $displayOnPages, $displayOnCats, $currentTime, $popupId ) );
				wp_safe_redirect( sanitize_text_field( $_POST['wptr_hidden_exit_referer'] ) . '&s3r4=updated&preview=no' );
			}
		}
	}
	
	private function force_download( $content, $filename ) {
		$fsize = strlen( $content );
		header( "Pragma: public" );
		header( "Expires: 0" );
		header( "Cache-Control: must-revalidate, post-check=0, pre-check=0" );
		header( "Cache-Control: private", false );
		header( "Content-type: application/force-download" );
		header( "Content-Disposition: attachment; filename=\"" . basename($filename) . "\";" );
		header( "Content-Transfer-Encoding: binary" );
		header( "Content-Length: " . $fsize );
		ob_clean();
		flush();
		echo $content;
		exit();
	}
	
	public function wptrafficmax_template_redirect() {
		if ( isset( $_GET['wptrnode'] ) && $_GET['wptrnode'] == 'download' ) {
			$couponUrl = base64_decode( $_GET['coupon'] );
			$content = file_get_contents( $couponUrl );
			$ext = end( explode( '.', $couponUrl ) );
			$filename = time() . '_coupon.' . $ext;
			self::force_download( $content, $filename );
		}
		
		global $wpdb;
		$tableInterstitials = $wpdb->prefix . 'wptr_interstitials';
		$getTheId = get_the_ID();
		$getTheCategory = get_the_category( $getTheId );
		$getCatId = $getTheCategory[0]->cat_ID;
		if ( is_null( $getCatId ) ) {
			$getCatId = 0;
		}
		$theId = '{'.$getTheId.'}';
		$theCatId = '{'.$getCatId.'}';
		$getInterstitialSetting = $wpdb->get_row( "SELECT * FROM $tableInterstitials WHERE display_on_posts LIKE '%$theId%' OR display_on_pages LIKE '%$theId%' OR display_on_cats LIKE '%$theCatId%' OR display_on_posts LIKE '%{ALL}%' OR display_on_pages LIKE '%{ALL}%' OR display_on_cats LIKE '%{ALL}%'" );
		if ( !is_null( $getInterstitialSetting ) ) {
			$autoClose = $getInterstitialSetting->autoclose;
			$countdownAutoclose = $getInterstitialSetting->countdown_autoclose;
			$cookieTime = $getInterstitialSetting->cookie_time;
			$cookieInterval = $getInterstitialSetting->cookie_interval;
			$isActive = $getInterstitialSetting->status;
			$getTheTitle = get_the_title( $getTheId );
			$content1 = stripslashes_deep( $getInterstitialSetting->content_1 );
			$content2 = stripslashes_deep( $getInterstitialSetting->content_2 );
			
			$jQuery = plugins_url( 'js/jquery-1.11.1.min.js', __FILE__ );
			$countdown = plugins_url( 'js/jquery.countdownTimer.min.js', __FILE__ );
			$cookie = plugins_url( 'js/jquery.cookie.js', __FILE__ );
			$bootstrapCss = plugins_url( 'css/bootstrap.min.css', __FILE__ );
			$fontAwesomeCss = plugins_url( 'css/font-awesome.min.css', __FILE__ );
			
			$sDisplayOnPosts = explode( ',', $getInterstitialSetting->display_on_posts );
			if ( in_array( '{ALL}', $sDisplayOnPosts ) ) {
				$a = true;
			} else {
				$a = false;
			}
			
			$sDisplayOnPages = explode( ',', $getInterstitialSetting->display_on_pages );
			if ( in_array( '{ALL}', $sDisplayOnPages ) ) {
				$b = true;
			} else {
				$b = false;
			}
			
			$sDisplayOnCategories = explode( ',', $getInterstitialSetting->display_on_cats );
			if ( in_array( '{ALL}', $sDisplayOnCategories ) ) {
				$e = true;
			} else {
				$e = false;
			}
			
			if ( $cookieInterval == 2 ) {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
jQuery.cookie( 'wptr-interstitial-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
				} else {
					$oCookie = '';
				}
			} else {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-interstitial-' + {$getTheId}, '1', { expires : date } );
COOKIE;
				} else {
					$oCookie = '';
				}
			}
			
			if ( $isActive && !is_front_page() ) {
				if ( $a ) {
					if ( is_single() ) {
						$c = 'SERA';
					} else {
						$c = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getInterstitialSetting->display_on_posts ) ) ) {
						if ( is_single() ) {
							$c = 'SERA';
						} else {
							$c = 'NTEP';
						}
					} else {
						$c = 'NTEP';
					}
				}
				
				if ( $b ) {
					if ( is_page() ) {
						$d = 'SERA';
					} else {
						$d = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getInterstitialSetting->display_on_pages ) ) ) {
						if ( is_page() ) {
							$d = 'SERA';
						} else {
							$d = 'NTEP';
						}
					} else {
						$d = 'NTEP';
					}
				}
				
				if ( $e ) {
					if ( is_single() ) {
						$f = 'SERA';
					} else {
						$f = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getCatId.'}', explode( ',', $getInterstitialSetting->display_on_cats ) ) ) {
						if ( is_single() ) {
							$f = 'SERA';
						} else {
							$f = 'NTEP';
						}
					} else {
						$f = 'NTEP';
					}
				}
				
				if ( $c == 'SERA' || $d == 'SERA' || $f == 'SERA' ) {
					if ( $_GET['whash'] == md5( 'wptr_' . $getTheId ) ) {
						setcookie( 'wptr-interstitial-' . $getTheId, '1', 0, '/' );
						if ( $getInterstitialSetting->onclose ) {
							wp_redirect( $getInterstitialSetting->redirect_url ); exit;
						} else {
							wp_redirect( get_permalink( $getTheId ) ); exit;
						}
					}
				
					$theUrl = get_permalink( $getTheId );
					if ( empty( $_COOKIE['wptr-interstitial-' . $getTheId] ) ) {
						if ( $autoClose ) {
							$thisTimer = '<span style="font-size:10px;">This message will close in <span id="interstitial-countdown"></span>.</span>';
						} else {
							$thisTimer = '';
						}
						echo <<<HTML
<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />
	<link rel="stylesheet" href="{$bootstrapCss}">
	<link rel="stylesheet" href="{$fontAwesomeCss}">
	<link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,600,700,900,300italic,400italic,600italic,700italic,900italic" type="text/css">
	<link rel="stylesheet" href="http://fonts.googleapis.com/css?family=Open+Sans:400,700" type="text/css">
	<script type="text/javascript" src="{$jQuery}"></script>
	<script type="text/javascript" src="{$countdown}"></script>
	<script type="text/javascript" src="{$cookie}"></script>
	<title>{$getTheTitle}</title>
	<style type="text/css">
		#content1 {
			background-color: {$getInterstitialSetting->bgcolor_1};
			color: {$getInterstitialSetting->textcolor_1};
		}
		#content2 {
			background-color: {$getInterstitialSetting->bgcolor_2};
			color: {$getInterstitialSetting->textcolor_2};
		}
	</style>
	<script type="text/javascript">
		$(document).ready(function(){
			console.log('S.E.R.A');
			
			if({$autoClose} == 1){
				jQuery('#interstitial-countdown').countdowntimer({
					seconds : {$countdownAutoclose},
					timeUp : function(){
						{$oCookie}
						if({$getInterstitialSetting->onclose} == 1){
							window.location.href = "{$getInterstitialSetting->redirect_url}";
						}else{
							window.location.reload();
						}
					}
				});
			}
			
			$(document).on('click', '#wptr-interstitial-destroyme', function(e){
				{$oCookie}
			});
		});
	</script>
</head>
<body>
	<div class="container-fluid">
		<div class="row">
			<div id="content1" class="col-lg-12 col-md-12 col-xs-12">
				<span style="padding-top:10px">{$content1}</span>
				<span class="pull-right">
					<a href="{$theUrl}" style="text-decoration:none;color:{$getInterstitialSetting->skiptextcolor};font-size:{$getInterstitialSetting->skiptextfontsize}px;" id="wptr-interstitial-destroyme">{$getInterstitialSetting->skiptext} &raquo;</a>
					<br/>{$thisTimer}
				</span>
			</div>
		</div>
		<div class="row">
			<div id="content2" class="col-lg-12 col-md-12 col-xs-12">
				<span style="padding-top:10px">{$content2}</span>
			</div>
		</div>
	</div>
</body>
</html>	
HTML;
				exit;
					}
				}
			}
		}
	}
	
	public function wptrafficmax_wp_footer() {
		global $wpdb;
		$tableWysiwygs = $wpdb->prefix . 'wptr_wysiwygs';
		$tableCoupons = $wpdb->prefix . 'wptr_coupons';
		$tableVideos = $wpdb->prefix . 'wptr_videos';
		$tableOptins = $wpdb->prefix . 'wptr_optins';
		$table2StepOptins = $wpdb->prefix . 'wptr_2stepoptins';
		$tableExit = $wpdb->prefix . 'wptr_exit';
		
		$getTheId = get_the_ID();
		$getTheCategory = get_the_category( $getTheId );
		$getCatId = $getTheCategory[0]->cat_ID;
		if ( is_null( $getCatId ) ) {
			$getCatId = 0;
		}
		$theId = '{'.$getTheId.'}';
		$theCatId = '{'.$getCatId.'}';
		
		$get2StepOptinSetting = $wpdb->get_row( "SELECT * FROM $table2StepOptins WHERE display_on_posts LIKE '%$theId%' OR display_on_pages LIKE '%$theId%' OR display_on_cats LIKE '%$theCatId%' OR display_on_posts LIKE '%{ALL}%' OR display_on_pages LIKE '%{ALL}%' OR display_on_cats LIKE '%{ALL}%'" );
		if ( !is_null( $get2StepOptinSetting ) ) {
			$autoClose = $get2StepOptinSetting->autoclose;
			$countdownAutoclose = $get2StepOptinSetting->countdown_autoclose;
			$delay = $get2StepOptinSetting->delay * 1000;
			$cookieTime = $get2StepOptinSetting->cookie_time;
			$cookieInterval = $get2StepOptinSetting->cookie_interval;
			$autosizePopup = $get2StepOptinSetting->autosize_popup;
			$isActive = $get2StepOptinSetting->status;
			$width = $get2StepOptinSetting->width;
			$widthOption = $get2StepOptinSetting->width_option;
			$height = $get2StepOptinSetting->height;
			$heightOption = $get2StepOptinSetting->height_option;
			if ( $widthOption == 'pixel' ) {
				$wOption = 'px';
			} else {
				$wOption = '%';
			}
			
			if ( $heightOption == 'pixel' ) {
				$hOption = 'px';
			} else {
				$hOption = '%';
			}
			
			$content1 = stripslashes_deep( $get2StepOptinSetting->content1 );
			$buttonStyle = $get2StepOptinSetting->button_style;
			$buttonSize = $get2StepOptinSetting->button_size; 
			$buttonColor = $get2StepOptinSetting->button_color;
			$content2 = stripslashes_deep( $get2StepOptinSetting->content2 );
			
			switch ( $buttonStyle ) {
				case 'flat':
					$classStyle = 'button button-flat';
				break;
				case 'glow':
					$classStyle = 'button glow';
				break;
				case 'rounded':
					$classStyle = 'button button-rounded';
				break;
				case '3d':
					$classStyle = 'button button-3d';
				break;
				case 'border':
					$classStyle = 'button button-border';
				break;
				case 'pill':
					$classStyle = 'button button-pill';
				break;
				case 'circle':
					$classStyle = 'button button-circle';
				break;
				case 'block':
					$classStyle = 'button button-block button-rounded';
				break;
				case 'wrapcircle':
					$classStyle = 'button button-circle';
				break;
				case 'wrappill':
					$classStyle = 'button button-pill';
				break;
			}
			
			if ( $buttonColor == 'default' ) {
				$classColor = '';
			} else {
				$classColor = 'button-' . $buttonColor;
			}
			
			if ( $buttonSize == 'default' ) {
				$classSize = '';
			} else {
				$classSize = 'button-' . $buttonSize;
			}
			
			if ( $buttonStyle == 'wrappill' ) {
				$cssButton = '<span class="button-wrap"><button id="wptr-2stepoptin-button" class="' . $classStyle . ' ' . $classColor . ' ' . $classSize . '">' . $get2StepOptinSetting->button_text . '</button></span>';
			} elseif ( $buttonStyle == 'wrapcircle' ) {
				$cssButton = '<span class="button-wrap"><button id="wptr-2stepoptin-button" class="' . $classStyle . ' ' . $classColor . '">' . $get2StepOptinSetting->button_text . '</button></span>';
			} else {
				$cssButton = '<button id="wptr-2stepoptin-button" class="' . $classStyle . ' ' . $classColor . ' ' . $classSize . '">' . $get2StepOptinSetting->button_text . '</button>';
			}
			
			$buttons = plugins_url( 'css/buttons.css', __FILE__ );
			$fancyBoxCsss = plugins_url( 'js/fancybox/jquery.fancybox.css', __FILE__ );
			$fancyBoxJs = plugins_url( 'js/fancybox/jquery.fancybox.pack.js', __FILE__ );
			
			if ( $autosizePopup ) {
				$oFitToView = 'true';
				$oAutoSize = 'true';
			} else {
				$oFitToView = 'false';
				$oAutoSize = 'false';
			}
			
			$sDisplayOnPosts = explode( ',', $get2StepOptinSetting->display_on_posts );
			if ( in_array( '{ALL}', $sDisplayOnPosts ) ) {
				$a = true;
			} else {
				$a = false;
			}
			
			$sDisplayOnPages = explode( ',', $get2StepOptinSetting->display_on_pages );
			if ( in_array( '{ALL}', $sDisplayOnPages ) ) {
				$b = true;
			} else {
				$b = false;
			}
			
			$sDisplayOnCategories = explode( ',', $get2StepOptinSetting->display_on_cats );
			if ( in_array( '{ALL}', $sDisplayOnCategories ) ) {
				$e = true;
			} else {
				$e = false;
			}
			
			if ( $cookieInterval == 2 ) {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
jQuery.cookie( 'wptr-2stepoptin-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
				} else {
					$oCookie = '';
				}
			} else {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-2stepoptin-' + {$getTheId}, '1', { expires : date } );
COOKIE;
				} else {
					$oCookie = '';
				}
			}
			
			if ( $isActive && !is_front_page() ) {
				if ( $a ) {
					if ( is_single() ) {
						$c = 'SERA';
					} else {
						$c = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $get2StepOptinSetting->display_on_posts ) ) ) {
						if ( is_single() ) {
							$c = 'SERA';
						} else {
							$c = 'NTEP';
						}
					} else {
						$c = 'NTEP';
					}
				}
				
				if ( $b ) {
					if ( is_page() ) {
						$d = 'SERA';
					} else {
						$d = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $get2StepOptinSetting->display_on_pages ) ) ) {
						if ( is_page() ) {
							$d = 'SERA';
						} else {
							$d = 'NTEP';
						}
					} else {
						$d = 'NTEP';
					}
				}
				
				if ( $e ) {
					if ( is_single() ) {
						$f = 'SERA';
					} else {
						$f = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getCatId.'}', explode( ',', $get2StepOptinSetting->display_on_cats ) ) ) {
						if ( is_single() ) {
							$f = 'SERA';
						} else {
							$f = 'NTEP';
						}
					} else {
						$f = 'NTEP';
					}
				}
				
				if ( $c == 'SERA' || $d == 'SERA' || $f == 'SERA' ) {
					if ( empty( $_COOKIE['wptr-2stepoptin-' . $getTheId] ) ) {
						if ( $autoClose ) {
							$thisTimer = '<span style="font-size:10px;">This message will close in <span id="2stepoptin-countdown"></span>.</span>';
						} else {
							$thisTimer = '';
						}
						
						echo <<<HTML
<link rel="stylesheet" type="text/css" href="{$fancyBoxCsss}"/>
<link rel="stylesheet" type="text/css" href="{$buttons}"/>
<script type="text/javascript" src="{$fancyBoxJs}"></script>
<script type="text/javascript">
	jQuery(document).ready(function(){
		setTimeout(function(){
			jQuery.fancybox({
				type: "inline",
				href: "#wptr-2stepoptin-popup1",
				fitToView	: {$oFitToView},
				width: "{$width}{$wOption}",
				height: "{$height}{$hOption}",
				autoSize: {$oAutoSize},
				closeClick: false,
				openEffect: 'none',
				closeEffect: 'none',
				keys: {
					close : null
				},
				beforeShow: function(){
					jQuery(".fancybox-skin").css("backgroundColor", "{$get2StepOptinSetting->bgcolor}");
				},
				helpers: {
					overlay : {closeClick: false}
				},
				afterClose: function(){
					{$oCookie}
					if({$get2StepOptinSetting->onclose} == 1 && jQuery.cookie( 'wptr-2stepoptin-' + {$getTheId} ) != 1){
						window.location.href = "{$get2StepOptinSetting->redirect_url}";
					}
				}
			});
			
			if({$autoClose} == 1){
				jQuery('#2stepoptin-countdown').countdowntimer({
					seconds : {$countdownAutoclose},
					timeUp : function(){
						{$oCookie}
						jQuery.fancybox.close(true);
						if({$get2StepOptinSetting->onclose} == 1){
							window.location.href = "{$get2StepOptinSetting->redirect_url}";
						}
					}
				});
			}
			
		},{$delay});
		
		jQuery(document).on('click', '#wptr-2stepoptin-button', function(e){
			jQuery.fancybox.close(true);
			jQuery.fancybox({
				type: "inline",
				href: "#wptr-2stepoptin-popup2",
				fitToView	: {$oFitToView},
				width: "{$width}{$wOption}",
				height: "{$height}{$hOption}",
				autoSize: {$oAutoSize},
				closeClick: false,
				openEffect: 'none',
				closeEffect: 'none',
				keys: {
					close : null
				},
				beforeShow: function(){
					jQuery(".fancybox-skin").css("backgroundColor", "{$get2StepOptinSetting->bgcolor}");
				},
				helpers: {
					overlay : {closeClick: false}
				},
				afterClose: function(){
					{$oCookie}
					if({$get2StepOptinSetting->onclose} == 1){
						setTimeout(function(){window.location.href = "{$get2StepOptinSetting->redirect_url}";}, 2000);
					}
				}
			});
		});
		
		if(jQuery('#mc-embedded-subscribe').length){
			jQuery(document).on('click', '#mc-embedded-subscribe', function(e){
				{$oCookie}
				/* jQuery.fancybox.close(true); */
			});
		}else{
			jQuery(document).on('submit', 'form', function(e){
				{$oCookie}
				/* jQuery.fancybox.close(true); */
			});
			
			jQuery(document).on('click', 'input[type="submit"]', function(e){
				{$oCookie}
				/* jQuery.fancybox.close(true); */
			});
		}
	});
</script>
<div id="wptr-2stepoptin-popup1">
	{$thisTimer}
	<div style="padding-top:10px;padding-bottom:20px;">{$content1}</div>
	<div style="text-align:center">
		{$cssButton}
	</div>
</div>

<div id="wptr-2stepoptin-popup2">
	<div style="padding-top:10px;padding-bottom:20px;">{$content2}</div>
</div>
HTML;
					}
				}
			}
		}
		
		$getVideoSetting = $wpdb->get_row( "SELECT * FROM $tableVideos WHERE display_on_posts LIKE '%$theId%' OR display_on_pages LIKE '%$theId%' OR display_on_cats LIKE '%$theCatId%' OR display_on_posts LIKE '%{ALL}%' OR display_on_pages LIKE '%{ALL}%' OR display_on_cats LIKE '%{ALL}%'" );
		if ( !is_null( $getVideoSetting ) ) {
			$autoClose = $getVideoSetting->autoclose;
			$countdownAutoclose = $getVideoSetting->countdown_autoclose;
			$delay = $getVideoSetting->delay * 1000;
			$cookieTime = $getVideoSetting->cookie_time;
			$cookieInterval = $getVideoSetting->cookie_interval;
			$autosizePopup = $getVideoSetting->autosize_popup;
			$videoSize = $getVideoSetting->video_size;
			$videoWidth = $getVideoSetting->video_width;
			$videoHeight = $getVideoSetting->video_height;
			$isActive = $getVideoSetting->status;
			$width = $getVideoSetting->width;
			$widthOption = $getVideoSetting->width_option;
			$height = $getVideoSetting->height;
			$heightOption = $getVideoSetting->height_option;
			if ( $widthOption == 'pixel' ) {
				$wOption = 'px';
			} else {
				$wOption = '%';
			}
			
			if ( $heightOption == 'pixel' ) {
				$hOption = 'px';
			} else {
				$hOption = '%';
			}
			
			$bgColor = $getVideoSetting->bgcolor;
			$videoAutoplay = $getVideoSetting->video_autoplay;
			$videoId = $getVideoSetting->video_id;
			$onPause = $getVideoSetting->onpause;
			$redirectUrlOnPause = $getVideoSetting->redirect_url_onpause;
			$onStop = $getVideoSetting->onstop;
			$redirectUrlOnStop = $getVideoSetting->redirect_url_onstop;
			$onEnd = $getVideoSetting->onend;
			$redirectUrlOnEnd = $getVideoSetting->redirect_url_onend;
			$contentVideoAbove = stripslashes_deep( $getVideoSetting->content_video_above );
			$contentVideoBelow = stripslashes_deep( $getVideoSetting->content_video_below );
			
			$fancyBoxCsss = plugins_url( 'js/fancybox/jquery.fancybox.css', __FILE__ );
			$fancyBoxJs = plugins_url( 'js/fancybox/jquery.fancybox.pack.js', __FILE__ );
			
			if ( $autosizePopup ) {
				$oFitToView = 'true';
				$oAutoSize = 'true';
			} else {
				$oFitToView = 'false';
				$oAutoSize = 'false';
			}
			
			switch ( $videoSize ) {
				case 1:
					$vWidth = '560px';
					$vHeight = '315px';
				break;
				case 2:
					$vWidth = '640px';
					$vHeight = '360px';
				break;
				case 3:
					$vWidth = '853px';
					$vHeight = '480px';
				break;
				case 4:
					$vWidth = '1280px';
					$vHeight = '720px';
				break;
				case 0;
					$vWidth = $getVideoSetting->video_width . 'px';
					$vHeight = $getVideoSetting->video_height . 'px';
				break;
			}
			
			$sDisplayOnPosts = explode( ',', $getVideoSetting->display_on_posts );
			if ( in_array( '{ALL}', $sDisplayOnPosts ) ) {
				$a = true;
			} else {
				$a = false;
			}
			
			$sDisplayOnPages = explode( ',', $getVideoSetting->display_on_pages );
			if ( in_array( '{ALL}', $sDisplayOnPages ) ) {
				$b = true;
			} else {
				$b = false;
			}
			
			$sDisplayOnCategories = explode( ',', $getVideoSetting->display_on_cats );
			if ( in_array( '{ALL}', $sDisplayOnCategories ) ) {
				$e = true;
			} else {
				$e = false;
			}
			
			if ( $cookieInterval == 2 ) {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
jQuery.cookie( 'wptr-video-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
				} else {
					$oCookie = '';
				}
			} else {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-video-' + {$getTheId}, '1', { expires : date } );
COOKIE;
				} else {
					$oCookie = '';
				}
			}
			
			if ( $isActive && !is_front_page() ) {
				if ( $a ) {
					if ( is_single() ) {
						$c = 'SERA';
					} else {
						$c = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getVideoSetting->display_on_posts ) ) ) {
						if ( is_single() ) {
							$c = 'SERA';
						} else {
							$c = 'NTEP';
						}
					} else {
						$c = 'NTEP';
					}
				}
				
				if ( $b ) {
					if ( is_page() ) {
						$d = 'SERA';
					} else {
						$d = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getVideoSetting->display_on_pages ) ) ) {
						if ( is_page() ) {
							$d = 'SERA';
						} else {
							$d = 'NTEP';
						}
					} else {
						$d = 'NTEP';
					}
				}
				
				if ( $e ) {
					if ( is_single() ) {
						$f = 'SERA';
					} else {
						$f = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getCatId.'}', explode( ',', $getVideoSetting->display_on_cats ) ) ) {
						if ( is_single() ) {
							$f = 'SERA';
						} else {
							$f = 'NTEP';
						}
					} else {
						$f = 'NTEP';
					}
				}
				
				if ( $c == 'SERA' || $d == 'SERA' || $f == 'SERA' ) {
					echo <<<RESOURCE
<link rel="stylesheet" type="text/css" href="{$fancyBoxCsss}"/>
<script type="text/javascript" src="{$fancyBoxJs}"></script>
RESOURCE;
					if ( empty( $_COOKIE['wptr-video-' . $getTheId] ) ) {
						if ( $autoClose ) {
							$thisTimer = '<span style="font-size:10px;">This message will close in <span id="video-countdown"></span>.</span>';
						} else {
							$thisTimer = '';
						}
						echo <<<HTML
<div id="wptr-video-popup">
	{$thisTimer}
	<div style="padding-top:10px;padding-bottom:15px;">{$contentVideoAbove}</div>
		<div id="wptr-video-player"></div>
	<div style="padding-top:15px;padding-bottom:10px;">{$contentVideoBelow}</div>
</div>

<script type="text/javascript">
	jQuery(document).ready(function(){
		setTimeout(function(){
			jQuery.fancybox({
				type: "inline",
				href: "#wptr-video-popup",
				fitToView	: {$oFitToView},
				width: "{$width}{$wOption}",
				height: "{$height}{$hOption}",
				autoSize: {$oAutoSize},
				closeClick: false,
				openEffect: 'none',
				closeEffect: 'none',
				keys: {
					close : null
				},
				beforeShow: function(){
					jQuery(".fancybox-skin").css("backgroundColor", "{$getVideoSetting->bgcolor}");
				},
				helpers: {
					overlay : {closeClick: false}
				},
				beforeClose: function(){
					jQuery('#wptr-video-popup').remove();
				},
				afterClose: function(){
					jQuery('#wptr-video-popup').remove();
					{$oCookie}
					if({$getVideoSetting->onclose} == 1){
						window.location.href = "{$getVideoSetting->redirect_url}";
					}
					setTimeout(function(){jQuery('#wptr-video-popup').remove();}, 2000);
				}
			});
			
			if({$autoClose} == 1){
				jQuery('#video-countdown').countdowntimer({
					seconds : {$countdownAutoclose},
					timeUp : function(){
						{$oCookie}
						jQuery.fancybox.close(true);
						if({$getVideoSetting->onclose} == 1){
							window.location.href = "{$getVideoSetting->redirect_url}";
						}
					}
				});
			}
			
		},{$delay});
	});
	
	var tag = document.createElement('script');
	tag.src = "https://www.youtube.com/iframe_api";
	var firstScriptTag = document.getElementsByTagName('script')[0];
	firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

	var player;
	function onYouTubePlayerAPIReady() {
    player = new YT.Player('wptr-video-player', {
			height: '{$vHeight}',
			width: '{$vWidth}',
			videoId: '{$videoId}',
			playerVars: { 'autoplay': {$videoAutoplay} }
    });
		player.addEventListener("onStateChange", "onYouTubePlayerStateChange");
  }
	
	function onYouTubePlayerStateChange(state) {
		switch(state.data){
			case 2:
				{$oCookie}
				if({$onPause} == 2){
					jQuery.fancybox.close(true);
				}
				
				if({$onPause} == 3){
					window.location.href = "{$redirectUrlOnPause}";
					console.log('S.E.R.A');
				}
			break;
			case 0:
				{$oCookie}
				if({$onEnd} == 2){
					jQuery.fancybox.close(true);
				}
				
				if({$onEnd} == 3){
					window.location.href = "{$redirectUrlOnEnd}";
				}
			break;
		}
	}
</script>
HTML;
					}
				}
			}
		}
		
		$getCouponSetting = $wpdb->get_row( "SELECT * FROM $tableCoupons WHERE display_on_posts LIKE '%$theId%' OR display_on_pages LIKE '%$theId%' OR display_on_cats LIKE '%$theCatId%' OR display_on_posts LIKE '%{ALL}%' OR display_on_pages LIKE '%{ALL}%' OR display_on_cats LIKE '%{ALL}%'" );
		if ( !is_null( $getCouponSetting ) ) {
			$autoClose = $getCouponSetting->autoclose;
			$countdownAutoclose = $getCouponSetting->countdown_autoclose;
			$delay = $getCouponSetting->delay * 1000;
			$cookieTime = $getCouponSetting->cookie_time;
			$cookieInterval = $getCouponSetting->cookie_interval;
			$autosizePopup = $getCouponSetting->autosize_popup;
			if ( $autosizePopup ) {
				$oFitToView = 'true';
				$oAutoSize = 'true';
			} else {
				$oFitToView = 'false';
				$oAutoSize = 'false';
			}
			
			$isActive = $getCouponSetting->status;
			$width = $getCouponSetting->width;
			$widthOption = $getCouponSetting->width_option;
			$height = $getCouponSetting->height;
			$heightOption = $getCouponSetting->height_option;
			if ( $widthOption == 'pixel' ) {
				$wOption = 'px';
			} else {
				$wOption = '%';
			}
			
			if ( $heightOption == 'pixel' ) {
				$hOption = 'px';
			} else {
				$hOption = '%';
			}
			
			$bgColor = $getCouponSetting->bgcolor;
			$coupon1 = $getCouponSetting->coupon_1;
			$contentCoupon1Above = stripslashes_deep( $getCouponSetting->content_coupon1_above );
			$contentCoupon1Below = stripslashes_deep( $getCouponSetting->content_coupon1_below );
			$coupon2 = $getCouponSetting->coupon_2;
			$contentCoupon2Above = stripslashes_deep( $getCouponSetting->content_coupon2_above );
			$contentCoupon2Below = stripslashes_deep( $getCouponSetting->content_coupon2_below );
			$theUrl = get_permalink( $getTheId );
			$theNonce = wp_create_nonce( 'wptrafficmax-nonce' );
			$theAjaxUrl = admin_url( 'admin-ajax.php' );
			$buttons = plugins_url( 'css/buttons.css', __FILE__ );
			$fancyBoxCsss = plugins_url( 'js/fancybox/jquery.fancybox.css', __FILE__ );
			$fancyBoxJs = plugins_url( 'js/fancybox/jquery.fancybox.pack.js', __FILE__ );
			
			$sDisplayOnPosts = explode( ',', $getCouponSetting->display_on_posts );
			if ( in_array( '{ALL}', $sDisplayOnPosts ) ) {
				$a = true;
			} else {
				$a = false;
			}
			
			$sDisplayOnPages = explode( ',', $getCouponSetting->display_on_pages );
			if ( in_array( '{ALL}', $sDisplayOnPages ) ) {
				$b = true;
			} else {
				$b = false;
			}
			
			$sDisplayOnCategories = explode( ',', $getCouponSetting->display_on_cats );
			if ( in_array( '{ALL}', $sDisplayOnCategories ) ) {
				$e = true;
			} else {
				$e = false;
			}
			
			if ( $cookieInterval == 2 ) {
				if ( $cookieTime != 0 ) {
					$oCookie1 = <<<COOKIE
jQuery.cookie( 'wptr-coupon-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
					$oCookie2 = <<<COOKIE
jQuery.cookie( 'wptr-coupon2-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
				} else {
					$oCookie1 = '';
					$oCookie2 = '';
				}
			} else {
				if ( $cookieTime != 0 ) {
					$oCookie1 = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
console.log(date);
jQuery.cookie( 'wptr-coupon-' + {$getTheId}, '1', { expires : date } );
COOKIE;
					$oCookie2 = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-coupon2-' + {$getTheId}, '1', { expires : date } );
COOKIE;
				} else {
					$oCookie1 = '';
					$oCookie2 = '';
				}
			}
			
			if ( $isActive && !is_front_page() ) {
				if ( $a ) {
					if ( is_single() ) {
						$c = 'SERA';
					} else {
						$c = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getCouponSetting->display_on_posts ) ) ) {
						if ( is_single() ) {
							$c = 'SERA';
						} else {
							$c = 'NTEP';
						}
					} else {
						$c = 'NTEP';
					}
				}
				
				if ( $b ) {
					if ( is_page() ) {
						$d = 'SERA';
					} else {
						$d = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getCouponSetting->display_on_pages ) ) ) {
						if ( is_page() ) {
							$d = 'SERA';
						} else {
							$d = 'NTEP';
						}
					} else {
						$d = 'NTEP';
					}
				}
				
				if ( $e ) {
					if ( is_single() ) {
						$f = 'SERA';
					} else {
						$f = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getCatId.'}', explode( ',', $getCouponSetting->display_on_cats ) ) ) {
						if ( is_single() ) {
							$f = 'SERA';
						} else {
							$f = 'NTEP';
						}
					} else {
						$f = 'NTEP';
					}
				}
				
				if ( $c == 'SERA' || $d == 'SERA' || $f == 'SERA' ) {
					echo <<<RESOURCE
<link rel="stylesheet" type="text/css" href="{$buttons}"/>
<link rel="stylesheet" type="text/css" href="{$fancyBoxCsss}"/>
<script type="text/javascript" src="{$fancyBoxJs}"></script>
RESOURCE;
					if ( empty( $_COOKIE['wptr-coupon-' . $getTheId] ) ) {
						if ( $autoClose ) {
							$thisTimer = '<span style="font-size:10px;">This message will close in <span id="coupon-countdown"></span>.</span>';
						} else {
							$thisTimer = '';
						}
					echo <<<HTML
<script type="text/javascript">
	jQuery(document).ready(function(){
		setTimeout(function(){
			jQuery.fancybox({
				type: "inline",
				href: "#wptr-coupon-popup1",
				fitToView: {$oFitToView},
				width: "{$width}{$wOption}",
				height: "{$height}{$hOption}",
				autoSize: {$oAutoSize},
				closeClick: false,
				openEffect: 'none',
				closeEffect: 'none',
				keys: {
					close : null
				},
				beforeShow: function(){
					jQuery(".fancybox-skin").css("backgroundColor", "{$getCouponSetting->bgcolor}");
				},
				helpers: {
					overlay : {closeClick: false}
				},
				afterClose: function(){
					{$oCookie1}
					{$oCookie2}
					
					if({$getCouponSetting->onclose} == 1){
						window.location.href = "{$getCouponSetting->redirect_url}";
					}
				}
			});
			
			if({$autoClose} == 1){
				jQuery('#coupon-countdown').countdowntimer({
					seconds : {$countdownAutoclose},
					timeUp : function(){
						{$oCookie1}
						{$oCookie2}
						
						jQuery.fancybox.close(true);
						if({$getCouponSetting->onclose} == 1){
							window.location.href = "{$getCouponSetting->redirect_url}";
						}
					}
				});
			}
			
		},{$delay});
		
		FB.Event.subscribe( 'edge.create',
			function ( url ) {
				objCoupon1 = new Object;
				objCoupon1.node = 'setCookieCoupon';
				objCoupon1.action = 'wptrafficmax_ajax';
				objCoupon1.wptrafficmax_nonce = '{$theNonce}';
				objCoupon1.url = url;
				jQuery.post( '{$theAjaxUrl}', objCoupon1, function ( res ) {
					{$oCookie1}
					window.location.reload();
				});
			}
		);
		
		FB.Event.subscribe( 'edge.remove',
			function ( url ) {
				objCoupon1 = new Object;
				objCoupon1.node = 'delCookieCoupon';
				objCoupon1.action = 'wptrafficmax_ajax';
				objCoupon1.wptrafficmax_nonce = '{$theNonce}';
				objCoupon1.url = url;
				jQuery.post( '{$theAjaxUrl}', objCoupon1, function ( res ) {
					jQuery.removeCookie( 'wptr-coupon-' + res );
				});
			}
		);
	
	});
</script>
<div id="wptr-coupon-popup1">
	{$thisTimer}
	<div style="padding-top:10px;padding-bottom:15px;">{$contentCoupon1Above}</div>
	<div style="text-align:center;">
		<div><img src="{$coupon1}" style="padding-bottom:10px;width:90%;height:90%;max-width:80%;max-height:80%;"/></div>
		<div class="fb-like" data-href="{$theUrl}" data-width="200" data-layout="box_count" data-action="like" data-show-faces="false" data-share="false"></div>
	</div>
	<div style="padding-top:15px;padding-bottom:10px;">{$contentCoupon1Below}</div>
</div>
HTML;
					}
				
					$hashDownload = md5( $coupon2 . '_' . $getTheId );
					$couponEncode = base64_encode( $coupon2 );
					if ( !empty( $_COOKIE['wptr-coupon-' . $getTheId] ) && empty( $_COOKIE['wptr-coupon2-' . $getTheId] ) ) {
						echo <<<HTML
<script type="text/javascript">
	jQuery(document).ready(function(){
		jQuery.fancybox({
			type: "inline",
			href: "#wptr-coupon-popup2",
			fitToView	: {$oFitToView},
			width: "{$width}{$wOption}",
			height: "{$height}{$hOption}",
			autoSize: {$oAutoSize},
			closeClick: false,
			openEffect: 'none',
			closeEffect: 'none',
			keys: {
				close : null
			},
			beforeShow: function(){
				jQuery(".fancybox-skin").css("backgroundColor", "{$getCouponSetting->bgcolor}");
			},
			helpers: {
				overlay : {closeClick: false}
			},
			afterClose: function(){
				{$oCookie2}
				if({$getCouponSetting->onclose} == 1){
					window.location.href = "{$getCouponSetting->redirect_url}";
				}
			}
		});
	});
</script>
<div id="wptr-coupon-popup2">
	<div style="padding-top:10px;padding-bottom:15px;">{$contentCoupon2Above}</div>
	<div class="wptr-print-me" style="text-align:center">
		<img src="{$coupon2}" style="width:90%;height:90%;max-width:80%;max-height:80%;padding-bottom:10px;"/>
	</div>
	<div style="text-align:center;">
		<a href="?wptrnode=download&coupon={$couponEncode}" class="button button-rounded button-small button-action" id="wptr-download-me">Download</a>&nbsp;<button class="button button-rounded button-small button-highlight" onClick="javascript:window.print()">Print</button>
	</div>
	<div style="padding-top:15px;padding-bottom:10px;">{$contentCoupon2Below}</div>
</div>
HTML;
					}
				}
			}
		}
		
		$getWysiwygSetting = $wpdb->get_row( "SELECT * FROM $tableWysiwygs WHERE display_on_posts LIKE '%$theId%' OR display_on_pages LIKE '%$theId%' OR display_on_cats LIKE '%$theCatId%' OR display_on_posts LIKE '%{ALL}%' OR display_on_pages LIKE '%{ALL}%' OR display_on_cats LIKE '%{ALL}%'" );
		if ( !is_null( $getWysiwygSetting ) ) {
			$autoClose = $getWysiwygSetting->autoclose;
			$countdownAutoclose = $getWysiwygSetting->countdown_autoclose;
			$delay = $getWysiwygSetting->delay * 1000;
			$cookieTime = $getWysiwygSetting->cookie_time;
			$cookieInterval = $getWysiwygSetting->cookie_interval;
			$autosizePopup = $getWysiwygSetting->autosize_popup;
			$isActive = $getWysiwygSetting->status;
			$width = $getWysiwygSetting->width;
			$widthOption = $getWysiwygSetting->width_option;
			$height = $getWysiwygSetting->height;
			$heightOption = $getWysiwygSetting->height_option;
			if ( $widthOption == 'pixel' ) {
				$wOption = 'px';
			} else {
				$wOption = '%';
			}
			
			if ( $heightOption == 'pixel' ) {
				$hOption = 'px';
			} else {
				$hOption = '%';
			}
			
			$content = stripslashes_deep( $getWysiwygSetting->content );
			$fancyBoxCsss = plugins_url( 'js/fancybox/jquery.fancybox.css', __FILE__ );
			$fancyBoxJs = plugins_url( 'js/fancybox/jquery.fancybox.pack.js', __FILE__ );
			
			$sDisplayOnPosts = explode( ',', $getWysiwygSetting->display_on_posts );
			if ( in_array( '{ALL}', $sDisplayOnPosts ) ) {
				$a = true;
			} else {
				$a = false;
			}
			
			$sDisplayOnPages = explode( ',', $getWysiwygSetting->display_on_pages );
			if ( in_array( '{ALL}', $sDisplayOnPages ) ) {
				$b = true;
			} else {
				$b = false;
			}
			
			$sDisplayOnCategories = explode( ',', $getWysiwygSetting->display_on_cats );
			if ( in_array( '{ALL}', $sDisplayOnCategories ) ) {
				$e = true;
			} else {
				$e = false;
			}
			
			if ( $cookieInterval == 2 ) {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
jQuery.cookie( 'wptr-wysiwyg-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
				} else {
					$oCookie = '';
				}
			} else {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-wysiwyg-' + {$getTheId}, '1', { expires : date } );
COOKIE;
				} else {
					$oCookie = '';
				}
			}
			
			if ( $isActive && !is_front_page() ) {
				if ( $a ) {
					if ( is_single() ) {
						$c = 'SERA';
					} else {
						$c = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getWysiwygSetting->display_on_posts ) ) ) {
						if ( is_single() ) {
							$c = 'SERA';
						} else {
							$c = 'NTEP';
						}
					} else {
						$c = 'NTEP';
					}
				}
				
				if ( $b ) {
					if ( is_page() ) {
						$d = 'SERA';
					} else {
						$d = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getWysiwygSetting->display_on_pages ) ) ) {
						if ( is_page() ) {
							$d = 'SERA';
						} else {
							$d = 'NTEP';
						}
					} else {
						$d = 'NTEP';
					}
				}
				
				if ( $e ) {
					if ( is_single() ) {
						$f = 'SERA';
					} else {
						$f = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getCatId.'}', explode( ',', $getWysiwygSetting->display_on_cats ) ) ) {
						if ( is_single() ) {
							$f = 'SERA';
						} else {
							$f = 'NTEP';
						}
					} else {
						$f = 'NTEP';
					}
				}
				
				if ( $c == 'SERA' || $d == 'SERA' || $f == 'SERA' ) {
					if ( empty( $_COOKIE['wptr-wysiwyg-' . $getTheId] ) ) {
						if ( $autoClose ) {
							$thisTimer = '<span style="font-size:10px;">This message will close in <span id="wysiwyg-countdown"></span>.</span>';
						} else {
							$thisTimer = '';
						}
						
						if ( $autosizePopup ) {
							$oFitToView = 'true';
							$oAutoSize = 'true';
						} else {
							$oFitToView = 'false';
							$oAutoSize = 'false';
						}
						echo <<<HTML
<link rel="stylesheet" type="text/css" href="{$fancyBoxCsss}"/>
<script type="text/javascript" src="{$fancyBoxJs}"></script>
<script type="text/javascript">
	jQuery(document).ready(function(){
		setTimeout(function(){
			jQuery.fancybox({
				type: "inline",
				href: "#wptr-wysiwyg-popup",
				fitToView	: {$oFitToView},
				width: "{$width}{$wOption}",
				height: "{$height}{$hOption}",
				autoSize: {$oAutoSize},
				closeClick: false,
				openEffect: 'none',
				closeEffect: 'none',
				keys: {
					close : null
				},
				beforeShow: function(){
					jQuery(".fancybox-skin").css("backgroundColor", "{$getWysiwygSetting->bgcolor}");
				},
				helpers: {
					overlay : {closeClick: false}
				},
				afterClose: function(){
					{$oCookie}
					if({$getWysiwygSetting->onclose} == 1){
						window.location.href = "{$getWysiwygSetting->redirect_url}";
					}
				}
			});
			
			if({$autoClose} == 1){
				jQuery('#wysiwyg-countdown').countdowntimer({
					seconds : {$countdownAutoclose},
					timeUp : function(){
						{$oCookie}
					
						jQuery.fancybox.close(true);
						if({$getWysiwygSetting->onclose} == 1){
							window.location.href = "{$getWysiwygSetting->redirect_url}";
						}
					}
				});
			}
			
		},{$delay});
	});
</script>
<div id="wptr-wysiwyg-popup">
	{$thisTimer}
	<div style="padding-top:10px;padding-bottom:10px;">
		{$content}
	</div>
</div>
HTML;
					}
				}
			}
		}
		
		$getOptinSetting = $wpdb->get_row( "SELECT * FROM $tableOptins WHERE display_on_posts LIKE '%$theId%' OR display_on_pages LIKE '%$theId%' OR display_on_cats LIKE '%$theCatId%' OR display_on_posts LIKE '%{ALL}%' OR display_on_pages LIKE '%{ALL}%' OR display_on_cats LIKE '%{ALL}%'" );
		if ( !is_null( $getOptinSetting ) ) {
			$autoClose = $getOptinSetting->autoclose;
			$countdownAutoclose = $getOptinSetting->countdown_autoclose;
			$delay = $getOptinSetting->delay * 1000;
			$cookieTime = $getOptinSetting->cookie_time;
			$cookieInterval = $getOptinSetting->cookie_interval;
			$autosizePopup = $getOptinSetting->autosize_popup;
			$isActive = $getOptinSetting->status;
			$width = $getOptinSetting->width;
			$widthOption = $getOptinSetting->width_option;
			$height = $getOptinSetting->height;
			$heightOption = $getOptinSetting->height_option;
			if ( $widthOption == 'pixel' ) {
				$wOption = 'px';
			} else {
				$wOption = '%';
			}
			
			if ( $heightOption == 'pixel' ) {
				$hOption = 'px';
			} else {
				$hOption = '%';
			}
			
			$content = stripslashes_deep( $getOptinSetting->content );
			$onSubscribePage = get_permalink( $getOptinSetting->onsubscribe_page );
			$fancyBoxCsss = plugins_url( 'js/fancybox/jquery.fancybox.css', __FILE__ );
			$fancyBoxJs = plugins_url( 'js/fancybox/jquery.fancybox.pack.js', __FILE__ );
			
			$sDisplayOnPosts = explode( ',', $getOptinSetting->display_on_posts );
			if ( in_array( '{ALL}', $sDisplayOnPosts ) ) {
				$a = true;
			} else {
				$a = false;
			}
			
			$sDisplayOnPages = explode( ',', $getOptinSetting->display_on_pages );
			if ( in_array( '{ALL}', $sDisplayOnPages ) ) {
				$b = true;
			} else {
				$b = false;
			}
			
			$sDisplayOnCategories = explode( ',', $getOptinSetting->display_on_cats );
			if ( in_array( '{ALL}', $sDisplayOnCategories ) ) {
				$e = true;
			} else {
				$e = false;
			}
			
			if ( $cookieInterval == 2 ) {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
jQuery.cookie( 'wptr-optin-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
				} else {
					$oCookie = '';
				}
			} else {
				if ( $cookieTime != 0 ) {
					$oCookie = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-optin-' + {$getTheId}, '1', { expires : date } );
COOKIE;
				} else {
					$oCookie = '';
				}
			}
			
			if ( $isActive && !is_front_page() ) {
				if ( $a ) {
					if ( is_single() ) {
						$c = 'SERA';
					} else {
						$c = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getOptinSetting->display_on_posts ) ) ) {
						if ( is_single() ) {
							$c = 'SERA';
						} else {
							$c = 'NTEP';
						}
					} else {
						$c = 'NTEP';
					}
				}
				
				if ( $b ) {
					if ( is_page() ) {
						$d = 'SERA';
					} else {
						$d = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getOptinSetting->display_on_pages ) ) ) {
						if ( is_page() ) {
							$d = 'SERA';
						} else {
							$d = 'NTEP';
						}
					} else {
						$d = 'NTEP';
					}
				}
				
				if ( $e ) {
					if ( is_single() ) {
						$f = 'SERA';
					} else {
						$f = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getCatId.'}', explode( ',', $getOptinSetting->display_on_cats ) ) ) {
						if ( is_single() ) {
							$f = 'SERA';
						} else {
							$f = 'NTEP';
						}
					} else {
						$f = 'NTEP';
					}
				}
				
				if ( $c == 'SERA' || $d == 'SERA' || $f == 'SERA' ) {
					if ( empty( $_COOKIE['wptr-optin-' . $getTheId] ) ) {
						if ( $autoClose ) {
							$thisTimer = '<span style="font-size:10px;">This message will close in <span id="optin-countdown"></span>.</span>';
						} else {
							$thisTimer = '';
						}
						
						if ( $autosizePopup ) {
							$oFitToView = 'true';
							$oAutoSize = 'true';
						} else {
							$oFitToView = 'false';
							$oAutoSize = 'false';
						}
						
						echo <<<HTML
<link rel="stylesheet" type="text/css" href="{$fancyBoxCsss}"/>
<script type="text/javascript" src="{$fancyBoxJs}"></script>
<script type="text/javascript">
	jQuery(document).ready(function(){
		setTimeout(function(){
			jQuery.fancybox({
				type: "inline",
				href: "#wptr-optin-popup",
				fitToView	: {$oFitToView},
				width: "{$width}{$wOption}",
				height: "{$height}{$hOption}",
				autoSize: {$oAutoSize},
				closeClick: false,
				openEffect: 'none',
				closeEffect: 'none',
				keys: {
					close : null
				},
				beforeShow: function(){
					jQuery(".fancybox-skin").css("backgroundColor", "{$getOptinSetting->bgcolor}");
				},
				helpers: {
					overlay : {closeClick: false}
				},
				afterClose: function(){
					{$oCookie}
					
					if('{$getOptinSetting->onsubscribe}' == 'redirect'){
						setTimeout(function(){window.location.href = "{$onSubscribePage}";}, 2000);
					}else if({$getOptinSetting->onclose} == 1 && '{$getOptinSetting->onsubscribe}' == 'close'){
						setTimeout(function(){window.location.href = "{$getOptinSetting->redirect_url}";}, 2000);
					}
				}
			});
			
			if({$autoClose} == 1){
				jQuery('#optin-countdown').countdowntimer({
					seconds : {$countdownAutoclose},
					timeUp : function(){
						{$oCookie}
						jQuery.fancybox.close(true);
						if({$getOptinSetting->onclose} == 1){
							window.location.href = "{$getOptinSetting->redirect_url}";
						}
					}
				});
			}
			
		},{$delay});
		
		if(jQuery('#mc-embedded-subscribe').length){
			jQuery(document).on('click', '#mc-embedded-subscribe', function(e){
				{$oCookie}
				/* jQuery.fancybox.close(true); */
			});
		}else{
			jQuery(document).on('submit', 'form', function(e){
				{$oCookie}
				/* jQuery.fancybox.close(true); */
			});
			
			jQuery(document).on('click', 'input[type="submit"]', function(e){
				{$oCookie}
				/* jQuery.fancybox.close(true); */
			});
		}
	});
</script>
<div id="wptr-optin-popup">
	{$thisTimer}
	<div style="padding-top:10px;padding-bottom:10px;">
		{$content}
	</div>
</div>
HTML;
					}
				}
			}
		}
		
		$getExitSetting = $wpdb->get_row( "SELECT * FROM $tableExit WHERE display_on_posts LIKE '%$theId%' OR display_on_pages LIKE '%$theId%' OR display_on_cats LIKE '%$theCatId%' OR display_on_posts LIKE '%{ALL}%' OR display_on_pages LIKE '%{ALL}%' OR display_on_cats LIKE '%{ALL}%'" );
		if ( !is_null( $getExitSetting ) ) {
			$content = $getExitSetting->content;
			$optionalUrl = $getExitSetting->url;
			$cookieTime = $getExitSetting->cookie_time;
			$cookieInterval = $getExitSetting->cookie_interval;
			$isActive = $getExitSetting->status;
			$excludePages = $getExitSetting->exclude_on_pages;
			$thisHost = $_SERVER['SERVER_NAME'];
			
			$sDisplayOnPosts = explode( ',', $getExitSetting->display_on_posts );
			if ( in_array( '{ALL}', $sDisplayOnPosts ) ) {
				$a = true;
			} else {
				$a = false;
			}
			
			$sDisplayOnPages = explode( ',', $getExitSetting->display_on_pages );
			if ( in_array( '{ALL}', $sDisplayOnPages ) ) {
				$b = true;
			} else {
				$b = false;
			}
			
			$sDisplayOnCategories = explode( ',', $getExitSetting->display_on_cats );
			if ( in_array( '{ALL}', $sDisplayOnCategories ) ) {
				$e = true;
			} else {
				$e = false;
			}
			
			if ( $cookieInterval == 2 ) {
				if ( $cookieTime != 0 ) {
					$oCookie1 = <<<COOKIE
jQuery.cookie( 'wptr-exit-' + {$getTheId}, '1', { expires : {$cookieTime} } );
COOKIE;
					$oCookie2 = <<<COOKIE
jQuery.cookie( 'wptr-cache-link-{$getTheId}', 'http://stefstef.me', { expires : {$cookieTime} } );
COOKIE;
				} else {
					$oCookie1 = '';
					$oCookie2 = '';
				}
			} else {
				if ( $cookieTime != 0 ) {
					$oCookie1 = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-exit-' + {$getTheId}, '1', { expires : date } );
COOKIE;
					$oCookie2 = <<<COOKIE
var date = new Date();
date.setTime( date.getTime() + ( {$cookieTime} * 60 * 60 * 1000 ) );
jQuery.cookie( 'wptr-cache-link-{$getTheId}', 'http://stefstef.me', { expires : date } );
COOKIE;
				} else {
					$oCookie1 = '';
					$oCookie2 = '';
				}
			}
			
			if ( $isActive && !is_front_page() ) {
				if ( $a ) {
					if ( is_single() ) {
						$c = 'SERA';
					} else {
						$c = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getExitSetting->display_on_posts ) ) ) {
						if ( is_single() ) {
							$c = 'SERA';
						} else {
							$c = 'NTEP';
						}
					} else {
						$c = 'NTEP';
					}
				}
				
				if ( $b ) {
					if ( is_page() ) {
						$d = 'SERA';
					} else {
						$d = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getTheId.'}', explode( ',', $getExitSetting->display_on_pages ) ) ) {
						if ( is_page() ) {
							$d = 'SERA';
						} else {
							$d = 'NTEP';
						}
					} else {
						$d = 'NTEP';
					}
				}
				
				if ( $e ) {
					if ( is_single() ) {
						$f = 'SERA';
					} else {
						$f = 'NTEP';
					}
				} else {
					if ( in_array( '{'.$getCatId.'}', explode( ',', $getExitSetting->display_on_cats ) ) ) {
						if ( is_single() ) {
							$f = 'SERA';
						} else {
							$f = 'NTEP';
						}
					} else {
						$f = 'NTEP';
					}
				}
				
				if ( $c == 'SERA' || $d == 'SERA' || $f == 'SERA' ) {
					if ( empty( $_COOKIE['wptr-exit-' . $getTheId] ) ) {
						if ( $excludePages ) {
							echo <<<SCRIPT
<script type="text/javascript">
var getLink = jQuery.cookie('wptr-cache-link-{$getTheId}');
jQuery(document).ready(function(){
	jQuery(document).on('click', 'a', function(e){
		getLink = jQuery(this).attr('href');
		if(getLink.indexOf('{$thisHost}') >= 0){
			window.onbeforeunload = null;
		}else{
			if(jQuery.cookie('wptr-exit-{$getTheId}') != 1){
				var firefox = /Firefox[\/\s](\d+)/.test(navigator.userAgent);
				if(!firefox){
					var unloading = false;
					var unloadMe = window.onbeforeunload = function (e) {
						unloading = true;
						getLink = '';
						return '{$content}';
					};
				
					setInterval(function(){
						if(unloading){
							unloading = false;
							setTimeout(function(){
								{$oCookie1}
								if('{$optionalUrl}' != ''){
									window.onbeforeunload = null;
									window.location.href = '{$optionalUrl}';
								}
							}, 100);
						}
					},100);
				}
			}
		}
	});
});
</script>
SCRIPT;
						}
						echo <<<SCRIPT
<script type="text/javascript">
if(jQuery.cookie('wptr-cache-link-{$getTheId}') != 'http://stefstef.me'){
	if(jQuery.cookie('wptr-exit-{$getTheId}') != 1){
		var firefox = /Firefox[\/\s](\d+)/.test(navigator.userAgent);
		if(!firefox){
			var unloading = false;
			window.onbeforeunload = function (e) {
				unloading = true;
				return '{$content}';
			};
		
			setInterval(function(){
				if(unloading){
					unloading = false;
					setTimeout(function(){
						{$oCookie1}
						{$oCookie2}
						if('{$optionalUrl}' != ''){
							window.onbeforeunload = null;
							window.location.href = '{$optionalUrl}';
						}
					}, 100);
				}
			},100);
		}
	}
}
</script>	
SCRIPT;
					}
				}
			}
		}
	}
	
	public function wptrafficmax_wp_head() {
		?>
		<script src="//connect.facebook.net/en_US/all.js#xfbml=1"></script>
		<style>
		.fb-like {
			overflow: hidden;
		}
		@media print {
			.wptr-print-me {
				background-color: white;
				position: fixed;
				top: 0;
				left: 0;
				margin: 0;
				padding: 15px;
				font-size: 14px;
				line-height: 18px;
			}
		}
		</style>
		<?php
	}
	
	public function wptrafficmax_ajax() {
		if ( !isset( $_POST['wptrafficmax_nonce'] ) || !wp_verify_nonce( $_POST['wptrafficmax_nonce'], 'wptrafficmax-nonce' ) ) {
			die( 'Permissions check failed.' );
		}
		
		global $wpdb;
		$tableCoupons = $wpdb->prefix . 'wptr_coupons';
		$tableVideos = $wpdb->prefix . 'wptr_videos';
		$tableWysiwygs = $wpdb->prefix. 'wptr_wysiwygs';
		$tableInterstitials = $wpdb->prefix . 'wptr_interstitials';
		$tableOptins = $wpdb->prefix . 'wptr_optins';
		$table2StepOptins = $wpdb->prefix . 'wptr_2stepoptins';
		$tableExit = $wpdb->prefix . 'wptr_exit';
		
		if ( isset( $_POST['node'] ) && $_POST['node'] == 'deletePopup' ) {
			$pId = sanitize_text_field( $_POST['pId'] );
			$pNode = sanitize_text_field( $_POST['pNode'] );
			
			if ( $pNode == 1 ) {
				$wpdb->query( $wpdb->prepare( "DELETE FROM $tableCoupons WHERE id = %d", $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 2 ) {
				$wpdb->query( $wpdb->prepare( "DELETE FROM $tableVideos WHERE id = %d", $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 3 ) {
				$wpdb->query( $wpdb->prepare( "DELETE FROM $tableWysiwygs WHERE id = %d", $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 4 ) {
				$wpdb->query( $wpdb->prepare( "DELETE FROM $tableInterstitials WHERE id = %d", $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 5 ) {
				$wpdb->query( $wpdb->prepare( "DELETE FROM $tableOptins WHERE id = %d", $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 6 ) {
				$wpdb->query( $wpdb->prepare( "DELETE FROM $table2StepOptins WHERE id = %d", $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 7 ) {
				$wpdb->query( $wpdb->prepare( "DELETE FROM $tableExit WHERE id = %d", $pId ) );
				echo 'OK';
			}
		}
		
		if ( isset( $_POST['node'] ) && $_POST['node'] == 'setCookieCoupon' ) {
			$theId = sanitize_text_field( $_POST['url'] );
			echo url_to_postid( $theId );
		}
		
		if ( isset( $_POST['node'] ) && $_POST['node'] == 'delCookieCoupon' ) {
			$theId = sanitize_text_field( $_POST['url'] );
			echo url_to_postid( $theId );
		}
		
		if ( isset( $_POST['node'] ) && $_POST['node'] == 'disablePopup' ) {
			$pId = sanitize_text_field( $_POST['pId'] );
			$pNode = sanitize_text_field( $_POST['pNode'] );
			
			if ( $pNode == 1 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableCoupons SET status = %d WHERE id = %d", 0, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 2 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableVideos SET status = %d WHERE id = %d", 0, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 3 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableWysiwygs SET status = %d WHERE id = %d", 0, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 4 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableInterstitials SET status = %d WHERE id = %d", 0, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 5 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableOptins SET status = %d WHERE id = %d", 0, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 6 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $table2StepOptins SET status = %d WHERE id = %d", 0, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 7 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableExit SET status = %d WHERE id = %d", 0, $pId ) );
				echo 'OK';
			}
		}
		
		if ( isset( $_POST['node'] ) && $_POST['node'] == 'enablePopup' ) {
			$pId = sanitize_text_field( $_POST['pId'] );
			$pNode = sanitize_text_field( $_POST['pNode'] );
			
			if ( $pNode == 1 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableCoupons SET status = %d WHERE id = %d", 1, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 2 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableVideos SET status = %d WHERE id = %d", 1, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 3 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableWysiwygs SET status = %d WHERE id = %d", 1, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 4 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableInterstitials SET status = %d WHERE id = %d", 1, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 5 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableOptins SET status = %d WHERE id = %d", 1, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 6 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $table2StepOptins SET status = %d WHERE id = %d", 1, $pId ) );
				echo 'OK';
			}
			
			if ( $pNode == 7 ) {
				$wpdb->query( $wpdb->prepare( "UPDATE $tableExit SET status = %d WHERE id = %d", 1, $pId ) );
				echo 'OK';
			}
		}
		die();
	}
	
	public function wptrafficmax_admin_head() {
		if ( is_admin() ) {
			?>
			<style type="text/css">
				table.wptrafficmaxs .row-actions{
					visibility: visible !important;
				}
				.fb-like {
					overflow: hidden;
				}
				.wptr-status-switch-1 {
					background-color: #5cb85c;
					display: inline;
					padding: .2em .6em .3em;
					font-size: 75%;
					line-height: 1;
					color: #fff;
					text-align: center;
					white-space: nowrap;
					vertical-align: baseline;
					border-radius: .25em;
				}
				.wptr-status-switch-2 {
					background-color: #d9534f;
					display: inline;
					padding: .2em .6em .3em;
					font-size: 75%;
					line-height: 1;
					color: #fff;
					text-align: center;
					white-space: nowrap;
					vertical-align: baseline;
					border-radius: .25em;
				}
			</style>
			<?php
		}
	}
	
	public function wptrafficmax_admin_footer() {
		self::_include( 'admin.footer' );
	}
}
new WPTrafficMax();
?>